!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1999 - 2003 H. Lischke, N. Zimmermann, T.J. Loeffler

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------


!==============================================================================
!
!  Name   :  IntToChar
!
!  Purpose:  Converts the  Integer value  intvalue to the character string
!            charvar of predefined length ndigits.
!            If the integer has less <ndigits digits, leading zeros are stored.
!
!  Remarks:  contains the subroutine
!
!            IntToChar (<PrepareMyOutput<TreeMigSlaveWork<...)
!
!==============================================================================


SUBROUTINE IntToChar(ndigits,intvalue,charvar)

IMPLICIT NONE

INTEGER, INTENT(IN):: ndigits, intvalue
CHARACTER, INTENT(OUT):: charvar(ndigits)
INTEGER:: idigit,digit,intval,digval,tenpower
CHARACTER(1):: digchar
 intval=intvalue
 DO idigit= ndigits,1,-1
   tenpower=10**(idigit-1)
   digit=Int(intval/tenpower)
   IF (digit>9) THEN
     print *, 'Too large number ',intvalue,' for this character array of length ', ndigits
     stop
   END IF
   digval =digit*tenpower
   intval =intval-digval
   digchar=CHAR(48+digit)
   charvar(ndigits-idigit+1)=digchar
  END DO
 END SUBROUTINE IntToChar
