!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2003 Joachim Gurtz, Massimiliano Zappa
! Modifications copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa,
! Marc Scherstjanoi, Heike Lischke
! 2014 - 2018: Adaptation of the old EINPUZDW to the FORHYCS structure

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Standard values for land-cover dependent parameters (by LC class and month)
! In most cases, parameterization is taken from old subroutine EINPUZDW
!-------------------------------------------------------------------------------

! Leaf area index
      stdLAI(1,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(2,:) = (/1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0/)
      stdLAI(3,:) = (/6.0,6.0,6.0,6.0,7.0,8.0,8.0,8.0,8.0,7.0,6.0,6.0/)
      stdLAI(4,:) = (/0.5,0.5,0.5,5.0,6.0,7.0,7.0,7.0,6.0,5.0,0.5,0.5/)
      stdLAI(5,:) = (/2.0,2.0,2.0,3.5,6.0,6.0,6.0,6.0,6.0,5.5,2.0,2.0/)
      stdLAI(6,:) = (/0.5,0.5,0.5,1.5,2.0,4.0,5.0,1.5,0.5,0.5,0.5,0.5/)
      stdLAI(7,:) = (/0.5,0.5,1.0,3.0,5.0,5.0,5.0,4.0,3.0,2.0,0.5,0.5/)
      stdLAI(8,:) = (/0.1,0.1,0.1,1.0,4.0,5.0,5.0,5.0,3.0,1.0,0.1,0.1/)
      stdLAI(9,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(10,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(11,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(12,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(13,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(14,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(15,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(16,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(17,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(18,:) = (/0.5,0.5,0.5,1.5,2.0,4.0,5.0,1.5,0.5,0.5,0.5,0.5/)
      stdLAI(19,:) =
     * (/0.20,0.20,0.2,1.0,5.0,5.0,5.0,5.0,4.0,2.5,0.25,0.25/)
      stdLAI(20,:) = (/0.5,0.5,0.5,1.5,2.0,4.0,5.0,1.5,0.5,0.5,0.5,0.5/)
      stdLAI(21,:) = (/0.1,0.1,0.1,0.1,1.5,3.0,4.0,4.0,3.0,1.0,0.1,0.1/)
      stdLAI(22,:) = (/0.1,0.1,0.1,0.1,1.5,3.0,4.0,4.0,3.0,1.0,0.1,0.1/)
      stdLAI(23,:) = (/0.1,0.1,0.1,0.1,1.5,3.0,4.0,3.5,2.5,1.0,0.1,0.1/)
      stdLAI(24,:) = (/0.1,0.1,0.1,0.1,1.5,2.0,2.5,3.0,3.0,1.0,0.1,0.1/)
      stdLAI(25,:) = (/0.1,0.1,0.1,0.1,0.5,1.5,2.0,2.0,2.0,1.0,0.1,0.1/)
      stdLAI(26,:) = (/0.1,0.1,0.1,0.1,0.5,1.0,1.5,1.5,1.5,0.5,0.1,0.1/)
      stdLAI(27,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdLAI(28,:) = (/0.1,0.1,0.1,0.1,0.1,1.0,3.0,5.0,5.0,5.0,0.1,0./)
      stdLAI(29,:) =
     * (/0.2,0.2,0.2,1.0,5.0,5.0,5.0,5.0,4.0,2.5,0.25,0.25/)
      stdLAI(30,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)


! Vegetation height
      stdZVeg(1,:) = (/0.005,0.005,0.005,0.005,0.005,0.005,0.005,
     * 0.005,0.005,0.005,0.005,0.005/)
      stdZVeg(2,:) = (/4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/)
      stdZVeg(3,:) = (/10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,
     * 10.0,10.0,10.0,10.0/)
      stdZVeg(4,:) = (/10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,
     * 10.0,10.0,10.0,10.0/)
      stdZVeg(5,:) = (/10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,
     * 10.0,10.0,10.0,10.0/)
      stdZVeg(6,:) =
     * (/0.05,0.05,0.05,0.10,0.40,0.60,0.80,0.80,0.30,0.10,0.05,0.05/)
      stdZVeg(7,:) =
     * ( /0.15,0.15,0.20,0.25,0.30,0.35,0.35,0.30,0.30,0.25,0.20,0.15/)
      stdZVeg(8,:) = (/1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0/)
      stdZVeg(9,:) = (/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(10,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(11,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(12,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(13,:) =(/0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,
     * 0.05,0.05,0.05,0.05/)
      stdZVeg(14,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(15,:) =(/0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,
     * 0.05,0.05,0.05,0.05/)
      stdZVeg(16,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(17,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(18,:) =
     * (/0.10,0.10,0.10,0.15,0.40,0.60,0.80,0.80,0.30,0.10,0.10,0.10/)
      stdZVeg(19,:) =
     * (/0.30,0.30,0.50,1.00,2.5,3.00,3.0,3.0,2.0,1.0,0.50,0.30/)
      stdZVeg(20,:) =
     * (/0.05,0.05,0.05,0.05,0.05,0.05,0.2,0.6,0.8,0.05,0.05,0.05/)
      stdZVeg(21,:) =(/0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,
     * 0.05,0.05,0.05,0.05/)
      stdZVeg(22,:) =
     * (/0.10,0.10,0.10,0.10,0.15,0.20,0.25,0.30,0.25,0.15,0.10,0.10/)
      stdZVeg(23,:) =
     * (/0.10,0.10,0.10,0.10,0.15,0.20,0.25,0.30,0.25,0.15,0.10,0.10/)
      stdZVeg(24,:) =
     * (/0.10,0.10,0.10,0.10,0.15,0.20,0.25,0.30,0.25,0.15,0.10,0.10/)
      stdZVeg(25,:) =
     * (/0.10,0.10,0.10,0.10,0.15,0.20,0.25,0.30,0.25,0.15,0.10,0.10/)
      stdZVeg(26,:) =
     * (/0.05,0.05,0.05,0.10,0.15,0.20,0.25,0.30,0.25,0.15,0.10,0.10/)
      stdZVeg(27,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZVeg(28,:) =(/2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0/)
      stdZVeg(29,:) =(/0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,
     * 0.05,0.05,0.05,0.05/)
      stdZVeg(30,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)



! Water holding capacity scaling factor (1 = WHC for forests)
      whcSF = (/0.0,0.0,1.0,1.0,1.0,0.44,0.44,1.0,0.0,0.0,0.0,0.0,0.0,
     * 0.0,0.0,0.0,0.0,0.53,0.44,0.44,0.22,1.0,0.22,0.22,0.22,0.22,0.0,
     * 0.44,0.44,0.0/)

! Minimal stomatal resistance

! FORHYCS modification (forests and potentially forested LC classes only):
! In coupled runs, RSMIN is calculated from tree species and heights. In
! uncoupled runs, standard values are assigned per unit leaf area. Stomatal
! resistance is scaled to canopy resistance in the subroutine EVAP. For
! non-forested vegetation types (agricultural), local water balance is
! calculated with the standard PREVAH routine. For consistency, RSMIN
! for these types is still given as canopy conductance.

      stdRSmin(1,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(2,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
C     stdRSmin(3,:) =
C    * (/55.0,55.0,55.0,50.0,40.0,40.0,40.0,45.0,55.0,55.0,55.0,55.0/)
C     stdRSmin(4,:) =
C    * (/65.0,65.0,65.0,60.0,45.0,50.0,50.0,53.0,60.0,65.0,65.0,65.0/)
C     stdRSmin(5,:) =
C    * (/63.0,63.0,63.0,60.0,43.0,48.0,48.0,51.0,60.0,63.0,63.0,63.0/)
      stdRSmin(3,:) =
     * (/180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,
     * 180.0,180.0/)
      stdRSmin(4,:) =
     * (/180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,
     * 180.0,180.0/)
      stdRSmin(5,:) =
     * (/180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,180.0,
     * 180.0,180.0/)
      stdRSmin(6,:) =
     * (/40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0/)
      stdRSmin(7,:) =
     * (/70.0,70.0,50.0,35.0,25.0,25.0,30.0,40.0,45.0,60.0,70.0,70.0/)
C     stdRSmin(8,:) =
C    * (/80.0,80.0,70.0,65.0,55.0,55.0,55.0,60.0,70.0,70.0,80.0,80.0/)
      stdRSmin(8,:) =
     * (/210.0,210.0,210.0,210.0,210.0,210.0,210.0,210.0,210.0,210.0,
     * 210.0,210.0/)
      stdRSmin(9,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(10,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(11,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(12,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(13,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(14,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(15,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(16,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(17,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(18,:) =
     * (/40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0,40.0/)
      stdRSmin(19,:) =
     * (/80.0,80.0,80.0,70.0,55.0,55.0,60.0,65.0,70.0,75.0,80.0,80.0/)
      stdRSmin(20,:) =
     * (/70.0,70.0,50.0,40.0,35.0,50.0,50.0,60.0,60.0,60.0,70.0,70.0/)
C     stdRSmin(21,:) =
C    * (/75.0,75.0,60.0,52.5,50.0,57.5,57.5,65.0,65.0,65.0,75.0,75.0/)
      stdRSmin(21,:) =
     * (/210.0,210.0,210.0,210.0,210.0,210.0,210.0,210.0,210.0,210.0,
     * 210.0,210.0/)
      stdRSmin(22,:) =
     * (/70.0,70.0,50.0,40.0,30.0,30.0,35.0,40.0,50.0,60.0,70.0,70.0/)
C     stdRSmin(23,:) =
C    * (/75.0,75.0,55.0,45.0,35.0,35.0,40.0,45.0,55.0,65.0,75.0,75.0/)
C     stdRSmin(24,:) =
C    * (/78.0,78.0,58.0,48.0,38.0,38.0,43.0,48.0,58.0,68.0,78.0,78.0/)
C     stdRSmin(25,:) =
C    * (/80.0,80.0,60.0,50.0,40.0,40.0,45.0,50.0,60.0,70.0,80.0,80.0/)
C     stdRSmin(26,:) =
C    * (/85.0,85.0,65.0,55.0,45.0,45.0,50.0,55.0,65.0,75.0,85.0,85.0/)
      stdRSmin(23,:) =
     * (/130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,
     * 130.0,130.0/)
      stdRSmin(24,:) =
     * (/130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,
     * 130.0,130.0/)
      stdRSmin(25,:) =
     * (/130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,
     * 130.0,130.0/)
      stdRSmin(26,:) =
     * (/130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,130.0,
     * 130.0,130.0/)
      stdRSmin(27,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdRSmin(28,:) =
     * (/80.0,80.0,80.0,70.0,55.0,55.0,60.0,65.0,65.0,75.0,80.0,80.0/)
      stdRSmin(29,:) =
     * ( /80.0,80.0,80.0,70.0,55.0,55.0,60.0,65.0,70.0,75.0,80.0,80.0/)
      stdRSmin(30,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)

! Rooting depth (used for non-forested vegetated classes)
      stdZroot(1,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZroot(2,:)=(/0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1/)
      stdZroot(3,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZroot(4,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZroot(5,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZroot(6,:)=(/0.2,0.2,0.2,0.2,0.2,0.2,0.8,0.8,0.8,0.2,0.2,0.2/)
      stdZroot(7,:)=(/0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6/)
      stdZroot(8,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdZroot(13,:)=(/0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2/)
      stdZroot(14,:)=(/0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1/)
      stdZroot(15,:)=(/0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1/)
      stdZroot(18,:)=(/0.2,0.2,0.2,0.2,0.5,0.7,0.8,0.8,0.5,0.2,0.2,0.2/)
      stdZroot(19,:)=(/0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8/)
      stdZroot(20,:)=(/0.2,0.2,0.2,0.2,0.4,0.6,0.8,0.8,0.8,0.2,0.2,0.2/)
      stdZroot(21,:)=(/0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5/)
      stdZroot(22,:)=(/0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3/)
      stdZroot(23,:)=(/0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3/)
      stdZroot(24,:)=(/0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3/)
      stdZroot(25,:)=(/0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3,0.3/)
      stdZroot(26,:)=
     * (/0.15,0.15,0.15,0.15,0.15,0.15,0.15,0.15,0.15,0.15,0.15,0.15/)
      stdZroot(28,:)=(/0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6,0.6/)
      stdZroot(29,:)=(/0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8,0.8/)

! Fractional vegetation cover

      stdVFrac(1,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(2,:) =(/0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2/)
      stdVFrac(3,:) =
     * (/0.92,0.92,0.93,0.94,0.95,0.97,1.00,1.00,1.00,0.98,0.97,0.96/)
      stdVFrac(4,:) =
     * ( /0.60,0.60,0.60,0.70,0.85,0.98,1.00,1.00,0.95,0.90,0.75,0.60/)
      stdVFrac(5,:) =
     * (/0.76,0.76,0.78,0.80,0.87,0.98,1.00,1.00,0.97,0.94,0.82,0.80/)
      stdVFrac(6,:) =
     * ( /0.40,0.40,0.50,0.60,0.80,1.00,1.00,1.00,0.50,0.30,0.30,0.40/)
      stdVFrac(7,:) =
     * (/0.90,0.90,0.92,0.94,0.96,0.98,0.98,0.98,0.95,0.92,0.90,0.90/)
      stdVFrac(8,:) =
     *  (/0.90,0.90,0.92,0.95,0.99,0.99,0.99,0.99,0.96,0.93,0.90,0.90/)
      stdVFrac(9,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(10,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(11,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(12,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(13,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(14,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(15,:)=(/0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1/)
      stdVFrac(16,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(17,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(18,:) =
     * (/0.40,0.40,0.50,0.60,0.80,1.00,1.00,1.00,0.50,0.30,0.30,0.40/)
      stdVFrac(19,:) =
     * (/0.70,0.70,0.75,0.80,0.90,0.95,0.95,0.95,0.95,0.90,0.80,0.75/)
      stdVFrac(20,:) =
     * (/0.40,0.40,0.50,0.60,0.80,1.00,1.00,1.00,0.00,0.20,0.30,0.40/)
      stdVFrac(21,:) =
     * (/0.80,0.80,0.80,0.80,0.80,0.90,0.90,0.90,0.85,0.80,0.80,0.80/)
      stdVFrac(22,:) =
     * (/0.80,0.80,0.80,0.80,0.80,0.90,0.90,0.90,0.85,0.80,0.80,0.80/)
      stdVFrac(23,:) =
     * (/0.70,0.70,0.70,0.70,0.70,0.80,0.80,0.80,0.75,0.70,0.70,0.70/)
      stdVFrac(24,:) =
     * (/0.60,0.60,0.60,0.60,0.60,0.70,0.70,0.70,0.65,0.60,0.60,0.60/)
      stdVFrac(25,:) =
     * (/0.50,0.50,0.50,0.50,0.50,0.60,0.60,0.60,0.55,0.50,0.50,0.50/)
      stdVFrac(26,:) =
     * (/0.30,0.30,0.30,0.30,0.30,0.40,0.40,0.40,0.35,0.30,0.30,0.30/)
      stdVFrac(27,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdVFrac(28,:) =
     * (/0.05,0.05,0.05,0.50,0.70,0.80,0.80,0.90,0.90,0.80,0.05,0.05/)
      stdVFrac(29,:) =
     * ( /0.50,0.50,0.55,0.70,0.90,0.90,0.90,0.90,0.90,0.80,0.60,0.50/)
      stdVFrac(30,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)


! SImax

      stdSImax(1,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(2,:) =(/5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0/)
      stdSImax(3,:) =
     * (/2.5,2.8,2.8,2.5,3.5,4.3,4.5,4.3,4.1,3.9,3.0,2.5/)
      stdSImax(4,:) =
     * (/1.5,1.5,1.5,2.0,3.0,3.5,3.5,3.3,3.2,2.7,2.0,1.5/)
      stdSImax(5,:) =
     *  (/2.0,2.2,2.2,2.3,3.3,3.9,4.0,3.8,3.6,3.2,2.5,2.0/)
      stdSImax(6,:)=(/0.5,0.5,0.5,1.5,2.5,3.0,3.0,2.5,2.0,1.5,1.0,0.5/)
      stdSImax(7,:)=(/1.5,1.5,1.8,2.3,3.0,3.5,3.5,3.2,2.8,2.0,1.5,1.5/)
      stdSImax(8,:)=(/1.5,1.5,1.5,2.0,2.8,3.0,3.0,2.8,2.4,2.0,1.7,1.5/)
      stdSImax(9,:) =(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(10,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(11,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(12,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(13,:)=(/0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5/)
      stdSImax(14,:)=(/0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5/)
      stdSImax(15,:)=(/4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/)
      stdSImax(16,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(17,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(18,:)=(/0.5,0.5,0.5,1.5,2.5,3.0,3.0,2.5,2.0,1.5,1.0,0.5/)
      stdSImax(19,:)=(/1.5,1.5,1.6,2.1,3.0,3.5,3.5,3.2,3.0,2.4,1.7,1.5/)
      stdSImax(20,:)=(/0.5,0.5,0.5,1.0,1.5,2.0,2.0,1.5,0.0,0.2,0.3,0.5/)
      stdSImax(21,:)=(/0.5,0.5,0.5,0.8,0.8,1.4,1.5,1.5,1.4,0.5,0.5,0.5/)
      stdSImax(22,:)=(/1.0,1.0,1.3,1.8,2.5,2.8,3.0,2.8,2.0,1.3,1.0,1.0/)
      stdSImax(23,:)=(/1.0,1.0,1.3,1.8,2.5,2.8,3.0,2.8,2.0,1.3,1.0,1.0/)
      stdSImax(24,:)=(/0.5,0.5,0.5,0.8,0.8,1.2,1.2,1.2,1.2,0.5,0.5,0.5/)
      stdSImax(25,:)=(/0.5,0.5,0.5,0.6,0.8,1.2,1.2,1.2,1.2,0.5,0.5,0.5/)
      stdSImax(26,:)=(/0.1,0.1,0.1,0.1,0.2,0.4,0.4,0.4,0.3,0.1,0.1,0.1/)
      stdSImax(27,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)
      stdSImax(28,:)=(/0.1,0.1,0.1,0.5,1.5,2.0,2.2,2.5,2.5,2.0,0.1,0.1/)
      stdSImax(29,:)=(/0.5,0.5,0.6,1.0,2.0,2.5,2.5,2.2,2.0,0.9,0.7,0.5/)
      stdSImax(30,:)=(/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/)

      !stdSImax = stdSImax*stdVFrac  ! Done in INTLOZ in original PREVAH

! Albedo

      stdAlb = (/0.05,0.10,0.12,0.17,0.15,0.25,0.25,0.25,0.10,0.20,
     *             0.30,0.05,0.10,0.40,0.12,0.70,0.50,0.25,0.20,0.25,
     *             0.20,0.20,0.23,0.23,0.25,0.20,0.20,0.20,0.20,0.20/)


      print*, "LC parameter initialization done", rank
