!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa, Marc
! Scherstjanoi, Heike Lischke

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Writes grids for LAI and land use
!-------------------------------------------------------------------------------

        upforest=.true.


! First: write LAI (WRGRD already contains LAI values)

      if(rank.ne.root) then
        call MPI_SEND(wrgrd(:,firstRow:lastRow),ncol*nrowLocal,
     *    MPI_REAL,root,22,MPI_COMM_WORLD,ierr)
      else  ! Master

        wrgrd=rnodat

        do j=1,numslaves
          call MPI_RECV(wrgrd(:,firstRowArray(j):lastRowArray(j)),
     *          ncol*nrowLocalArray(j),MPI_REAL,j,22,
     *          MPI_COMM_WORLD,status,ierr)
        end do

         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *          forestyy//".lai"
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')

        uwas=732
	 include 'wstsp.inc'

      end if

      call MPI_BARRIER(MPI_COMM_WORLD,ierr)
! Second: write land use grid

      if(rank.ne.root) then
        wrgrd=landin

        call MPI_SEND(wrgrd(:,firstRow:lastRow),ncol*nrowLocal,
     *    MPI_REAL,root,22,MPI_COMM_WORLD,ierr)

      else  ! Master

         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *          forestyy//"_use.lai"

        wrgrd=rnodat

        do j=1,numslaves
          call MPI_RECV(wrgrd(:,firstRowArray(j):lastRowArray(j)),
     *          ncol*nrowLocalArray(j),MPI_REAL,j,22,
     *          MPI_COMM_WORLD,status,ierr)

        end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	 include 'wstsp.inc'

      end if
