!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa, Marc
! Scherstjanoi, Heike Lischke

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Writes grids for monthly output
!-------------------------------------------------------------------------------

      if(rank==root) then
        write(CHJA ,'(I4)')JAHR
        CALL CHARNR (MON,CHMO)
      end if

      call MPI_BCAST(chja,4,MPI_CHARACTER,root,MPI_COMM_WORLD,ierr)
      call MPI_BCAST(chmo,4,MPI_CHARACTER,root,MPI_COMM_WORLD,ierr)

      DO I=1,25

          IF (whgrid(I)(3:3) .EQ. 'N') CYCLE
          IF (whgrid(I)(3:3) .EQ. 'n') CYCLE

         namgrd=diroutput(1:posi3)//
     *   idnam(posiid1:posiid2)//CHJA//CHMO//'mm'//ergrid(I)

        if (rank .ne. root) then
	   do ycoor=firstRow,lastRow
	   do xcoor=1,ncol
            if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
	       WRGRD(xcoor,ycoor)=rnodat
		cycle
	     else

              select case(i)

                case(1)
                  WRGRD(xcoor,ycoor)=PAKMS(xcoor,ycoor)

                case(2)
                  !WRGRD(xcoor,ycoor)=EPMS(xcoor,ycoor)
                  WRGRD(xcoor,ycoor)=peTransMS(xcoor,ycoor)

                case(3)
                  !WRGRD(xcoor,ycoor)=ERMS(xcoor,ycoor)
                  WRGRD(xcoor,ycoor)=eTransMS(xcoor,ycoor)

                case(4)
                  !WRGRD(xcoor,ycoor)=EIMS(xcoor,ycoor)
                  WRGRD(xcoor,ycoor)=eIntMS(xcoor,ycoor)

                case(5)
                  WRGRD(xcoor,ycoor)=EBMS(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=eIntMS(xcoor,ycoor)

                case(6)
                  WRGRD(xcoor,ycoor)=RGEMS(xcoor,ycoor)

                case(7)
                  WRGRD(xcoor,ycoor)=R0MS(xcoor,ycoor)
                   !WRGRD(xcoor,ycoor)=eSnowMS(xcoor,ycoor)

                case(8)
                  WRGRD(xcoor,ycoor)=R1MS(xcoor,ycoor)
                   !WRGRD(xcoor,ycoor)=eWaterMS(xcoor,ycoor)

                case(9)
                  WRGRD(xcoor,ycoor)=R2MS(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=peTrans1MS(xcoor,ycoor)

                case(10)
                  WRGRD(xcoor,ycoor)=GLACMS(xcoor,ycoor)
                   !WRGRD(xcoor,ycoor)=eTrans2MS(xcoor,ycoor)
                case(12)
                  WRGRD(xcoor,ycoor)=WSAMS(xcoor,ycoor)

                case(13)
                  WRGRD(xcoor,ycoor)=GWNBMS(xcoor,ycoor)

                case(14)
                  WRGRD(xcoor,ycoor)=SSOTF(xcoor,ycoor)
	           if (WRGRD(xcoor,ycoor) .lt. 1.) WRGRD(xcoor,ycoor)=0.

                case(15)
                  WRGRD(xcoor,ycoor)=SITF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=peTrans2MS(xcoor,ycoor)

                case(16)
                  WRGRD(xcoor,ycoor)=SSMTF(xcoor,ycoor)

                case(17)
                  WRGRD(xcoor,ycoor)=SUZTF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=qsmon(xcoor,ycoor)

                case(18)
                  WRGRD(xcoor,ycoor)=SLZTF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=qlmon(xcoor,ycoor)

                case(19)
                  WRGRD(xcoor,ycoor)=SLZ1TF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=qgmon(xcoor,ycoor)

                case(20)
                  WRGRD(xcoor,ycoor)=snowdaystf(xcoor,ycoor,1)

                case(21)
                  WRGRD(xcoor,ycoor)=SSMTF(xcoor,ycoor)/
     *            SFCTF(xcoor,ycoor)

                case(22)
                  WRGRD(xcoor,ycoor)=peSoilMS(xcoor,ycoor)
                case(23)
                  WRGRD(xcoor,ycoor)=eSoilMS(xcoor,ycoor)
                case(24)
                  WRGRD(xcoor,ycoor)=esnowMS(xcoor,ycoor)
                case(25)
                  WRGRD(xcoor,ycoor)=simaxtf(xcoor,ycoor)

              end select
            end if
          end do
          end do

          call MPI_SEND(wrgrd(:,firstRow:lastRow),ncol*nrowLocal,
     *    MPI_REAL,root,22,MPI_COMM_WORLD,ierr)

        else  ! Master
          wrgrd=rnodat

        do j=1,numslaves
          call MPI_RECV(wrgrd(:,firstRowArray(j):lastRowArray(j)),
     *          ncol*nrowLocalArray(j),MPI_REAL,j,22,
     *          MPI_COMM_WORLD,status,ierr)
        end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
        include 'wstsp.inc'


! Special cases for output: all handled by master

      IF (I .eq. 21) then
         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.smdeficit'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=fsad_tf(xcoor,ycoor,6)/MONUM(MON)/24
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'
	end if

! FORHYCS Output
	    IF (I .eq. 15) then
         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.rlai_phen'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=forhycs(xcoor,ycoor,1)
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'

         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.simax'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=forhycs(xcoor,ycoor,2)
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'
	end if

! Final snow ablation day, output in september

	    IF ((I .eq. 20) .and. (mon .eq. 9)) then

         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.snowdays'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=snowdaystf(xcoor,ycoor,1)-
     *         snowdaystf(xcoor,ycoor,2)
         snowdaystf(xcoor,ycoor,2)=snowdaystf(xcoor,ycoor,1)
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
	    fsad_tf(xcoor,ycoor,1)=0
	    fsad_tf(xcoor,ycoor,2)=0
	    fsad_tf(xcoor,ycoor,3)=273
	    fsad_tf(xcoor,ycoor,4)=0
	    fsad_tf(xcoor,ycoor,5)=0
		end if
	end do
	end do
		END IF
      end if  ! Master / Slaves

      end do  ! Loop over variables
