!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa, Marc
! Scherstjanoi, Heike Lischke

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Writes yearly grids
!-------------------------------------------------------------------------------

      if(rank==root) then
        write(CHJA ,'(I4)')JAHR
      end if
      call MPI_BCAST(chja,4,MPI_CHARACTER,root,MPI_COMM_WORLD,ierr)

        DO I=1,25

          IF (whgrid(I)(5:5) .EQ. 'N') CYCLE
          IF (whgrid(I)(5:5) .EQ. 'n') CYCLE

          namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *          CHJA//ergrid(I)

        if(rank.ne.root) then
	   do ycoor=firstRow,lastRow
	   do xcoor=1,ncol
            if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
	       WRGRD(xcoor,ycoor)=rnodat
		cycle
	     else

              select case(i)

                case(1)
                  WRGRD(xcoor,ycoor)=PAKJS(xcoor,ycoor)

                case(2)
                  !WRGRD(xcoor,ycoor)=EPJS(xcoor,ycoor)
                  WRGRD(xcoor,ycoor)=peTransJS(xcoor,ycoor)

                case(3)
                  !WRGRD(xcoor,ycoor)=ERJS(xcoor,ycoor)
                  WRGRD(xcoor,ycoor)=eTransJS(xcoor,ycoor)

                case(4)
                  !WRGRD(xcoor,ycoor)=EIJS(xcoor,ycoor)
                  WRGRD(xcoor,ycoor)=eIntJS(xcoor,ycoor)

                case(5)
                  WRGRD(xcoor,ycoor)=EBJS(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=eIntJS(xcoor,ycoor)

                case(6)
                  WRGRD(xcoor,ycoor)=RGEJS(xcoor,ycoor)

                case(7)
                  WRGRD(xcoor,ycoor)=R0JS(xcoor,ycoor)
                  ! WRGRD(xcoor,ycoor)=eSnowJS(xcoor,ycoor)

                case(8)
                  WRGRD(xcoor,ycoor)=R1JS(xcoor,ycoor)
                  ! WRGRD(xcoor,ycoor)=eWaterJS(xcoor,ycoor)

                case(9)
                  WRGRD(xcoor,ycoor)=R2JS(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=peTrans1JS(xcoor,ycoor)

                case(10)
                  WRGRD(xcoor,ycoor)=GLACJS(xcoor,ycoor)
                  ! WRGRD(xcoor,ycoor)=eTrans2JS(xcoor,ycoor)
                case(12)
                  WRGRD(xcoor,ycoor)=WSAJS(xcoor,ycoor)

                case(13)
                  ! TEMPORARY
                  WRGRD(xcoor,ycoor)=GWNBJS(xcoor,ycoor)
                  !wrgrd(xcoor,ycoor) = MTDbil(xcoor,ycoor)

                case(14)
                  WRGRD(xcoor,ycoor)=SSOTF(xcoor,ycoor)
	           if (WRGRD(xcoor,ycoor) .lt. 1.) WRGRD(xcoor,ycoor)=0.

                case(15)
                  WRGRD(xcoor,ycoor)=SITF(xcoor,ycoor)
                  ! WRGRD(xcoor,ycoor)=peTrans2JS(xcoor,ycoor)
                case(16)
                  WRGRD(xcoor,ycoor)=SSMTF(xcoor,ycoor)

                case(17)
                  WRGRD(xcoor,ycoor)=SUZTF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=qsyr(xcoor,ycoor)

                case(18)
                  WRGRD(xcoor,ycoor)=SLZTF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=qlyr(xcoor,ycoor)

                case(19)
                  WRGRD(xcoor,ycoor)=SLZ1TF(xcoor,ycoor)
                  !WRGRD(xcoor,ycoor)=qgyr(xcoor,ycoor)

                case(20)
                !TEMPORARY
                  WRGRD(xcoor,ycoor)=snowdaystf(xcoor,ycoor,1)
                  !WRGRD(xcoor,ycoor)=glacbily2d(xcoor,ycoor)

                case(21)
                  WRGRD(xcoor,ycoor)=SSMTF(xcoor,ycoor)/
     *            SFCTF(xcoor,ycoor)

                case(22)
                  WRGRD(xcoor,ycoor)=peSoilJS(xcoor,ycoor)
                case(23)
                  WRGRD(xcoor,ycoor)=eSoilJS(xcoor,ycoor)
                case(24)
                  WRGRD(xcoor,ycoor)=esnowJS(xcoor,ycoor)
                case(25)
                  WRGRD(xcoor,ycoor)=simaxtf(xcoor,ycoor)


              end select
            end if
          end do
          end do

        call MPI_SEND(wrgrd(:,firstRow:lastRow),ncol*nrowLocal,
     *    MPI_REAL,root,22,MPI_COMM_WORLD,ierr)

        else  ! Master

          wrgrd=rnodat

        do j=1,numslaves
          call MPI_RECV(wrgrd(:,firstRowArray(j):lastRowArray(j)),
     *          ncol*nrowLocalArray(j),MPI_REAL,j,22,
     *          MPI_COMM_WORLD,status,ierr)

        end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
        include 'wstsp.inc'
      end if

      end do
