!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1999 - 2003 H. Lischke, N. Zimmermann, T.J. Loeffler

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------



!==============================================================================
!
!  Name   :  OpenAndWriteHeader
!
!  Remarks:  contains the subroutine
!
!            OpenAndWriteHeader (<PrepareOutput<TreeMig)
!
!==============================================================================



SUBROUTINE OpenAndWriteHeader(iunit, fn, tabsepOutput, nspc)

!<CALL modules for type definitions>---------------------------------------------------------------
USE All_par, ONLY: spec, pathletter1, pathletter2
use prevahglobals, ONLY: diroutput
use forhycsglobals, only: tpswitch

IMPLICIT NONE

!<Passed variables>--------------------------------------------------------------------------------
INTEGER, INTENT(IN)      :: iunit, nspc
LOGICAL, INTENT(IN)      :: tabsepOutput
CHARACTER*26, INTENT(IN) :: fn

!<Local variables>---------------------------------------------------------------------------------
INTEGER      :: ispec, tmpos
CHARACTER*256 :: pathfn
Character*1  :: tab

!<Here the subroutine starts>**********************************************************************
  IF (tabsepOutput) THEN
    tab = CHAR(9)
  ELSE
    tab = ','
  END IF

  CALL POSNAM (diroutput,1,tmpos)
  pathfn =  diroutput(1:tmpos)//'treemig'//pathletter2//'R'//pathletter2//tpswitch//'_'//fn

  OPEN(UNIT=iunit, FILE=trim(pathfn), STATUS='unknown')
  WRITE(iunit,100)  "lat ", tab, "lon ", tab, "year", tab, &
                  (spec(ispec)%nl, tab, ispec=1,nspc), "all species"

  100 FORMAT(4(A4,A1),31(A,A1))
END SUBROUTINE OpenAndWriteHeader
!****<Here the subroutine ends>********************************************************************  SUBROUTINE OpenAndWriteHeader(iunit, fn, tabsepOutput, nspc)
