!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.
! Modifications Copyright (C) 2018 Matthias Speich
! 2014-2018: Adapt the subroutine to the disaggregated soil evaporation and
! transpiration calculation.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

! building daily sums

      PNDS=PNDS+PNAKT(I)
      PAKDS=PAKDS+PAKT(I)
      WSADS=WSADS+WSB
      EPDS=EPDS+EPDT
      ERDS=ERDS+ERDT
      EIDS=EIDS+EIDT
      EBDS=EBDS+EBDT
	  DIFGADM=DIFGADM+(PRLDIFGA/wstats(1))
      R0DS=R0DS+R0
      R1DS=R1DS+R1
      R2DS=R2DS+R2
	  rgb1dm=rgb1dm+(RG1/wstats(1))
	  rgb2dm=rgb2dm+(RG2/wstats(1))
	  rgb3dm=rgb3dm+(RG3/wstats(1))
      RGEDS=RGEDS+RGES
      GWNBDS=GWNBDS+PERC

      IF (LAND .EQ. 14) GLACDS=GLACDS+WICE

      !petDS = petDS + peTrans + peSoil
      petDS = 0.0
      peSoilDS = peSoilDS + peSoil
      peTransDS = peTransDS + peTrans
      eSoilDS = eSoilDS + eSoil
      eTransDS = eTransDS + eTrans
      eSnowDS = eSnowDS + eSnow
      eIntDS = eIntDS + eidt
      eWaterDS = eWaterDS + eWater
      peDS = peDS + pe

! building hourly values for the whole catchment
      ATFLK=ATFL(xcoor,ycoor)*0.01
      PNKHM(I)=PNKHM(I)+(PNAKT(I)/wstats(1))
      PAKHM(I)=PAKHM(I)+(PAKT(I)/wstats(1))
      WSAHM(I)=WSAHM(I)+(WSB/wstats(1))
      EPHM(I)=EPHM(I)+(EPDT/wstats(1))
      ERHM(I)=ERHM(I)+(ERDT/wstats(1))
      EIHM(I)=EIHM(I)+(EIDT/wstats(1))
      EBHM(I)=EBHM(I)+(EBDT/wstats(1))
      R0HM(I)=R0HM(I)+(R0/wstats(1))
      R1HM(I)=R1HM(I)+(R1/wstats(1))
      R2HM(I)=R2HM(I)+(R2/wstats(1))
	  RGB1HM(I)=RGB1HM(I)+(RG1/wstats(1))
	  RGB2HM(I)=RGB2HM(I)+(RG2/wstats(1))
	  RGB3HM(I)=RGB3HM(I)+(RG3/wstats(1))
      RGEHM(I)=RGEHM(I)+(RGES/wstats(1))
      WICEHM(I)=WICEHM(I)+(WICE/wstats(1))
      RICEHM(I)=RICEHM(I)+(RICE/wstats(1))
      RICSHM(I)=RICSHM(I)+(RICS/wstats(1))
      RICFHM(I)=RICFHM(I)+(RICF/wstats(1))
      SSMHM(I)=SSMHM(I)+(SSMTF(xcoor,ycoor)/wstats(1))
      SSOHM(I)=SSOHM(I)+(SSOTF(xcoor,ycoor)/wstats(1))
      SIHM(I)=SIHM(I)+(SITF(xcoor,ycoor)/wstats(1))
      SUZHM(I)=SUZHM(I)+(SUZTF(xcoor,ycoor)/wstats(1))
      SLZHM(I)=SLZHM(I)+(SLZTF(xcoor,ycoor)/wstats(1))
