!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa, Marc
! Scherstjanoi, Heike Lischke

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

! allocate FORHYCS-specific variables after TreeMig initialization

      allocate(phantomSeedsIn(ncol,nrow,maxspc))
      allocate(phantomSeedsOut(ncol,nrow,maxspc))
      allocate(phantomSeedsSum(ncol,nrow,maxspc))
      allocate(biomass2d(ncol,nrow,maxspc+2))
      allocate(stnum2d(ncol,nrow,maxspc+2))
      allocate(number2d(ncol,nrow,maxspc+2))
      allocate(seeds2d(ncol,nrow,maxspc+2))
      allocate(ingrowth2d(ncol,nrow,maxspc+2))
      allocate(antagon2d(ncol,nrow,maxspc+2))
      allocate(pollen2d(ncol,nrow,maxspc+2))
      allocate(la2d(ncol,nrow,maxspc+2))
      allocate(biomassTable(maxspc+2,ncol*nrow))
      allocate(numberTable(maxspc+2,ncol*nrow))
      allocate(seedsTable(maxspc+2,ncol*nrow))
      allocate(ingrowthTable(maxspc+2,ncol*nrow))
      allocate(antagonTable(maxspc+2,ncol*nrow))
      allocate(pollenTable(maxspc+2,ncol*nrow))
      allocate(laTable(maxspc+2,ncol*nrow))

      !allocate(fracCover(ncol,nrow))

      allocate(laRed(maxspc,(maxhc)))

      allocate(Schill(ncol, nrow, maxspc))
      Schill = 0.0
      allocate(Sforcing(ncol, nrow, maxspc))
      Sforcing = 0.0
      allocate(doyBB(ncol, nrow, maxspc))
      doyBB = 0
      allocate(doySen(ncol, nrow, maxspc))
      doySen = 0
      allocate(meanT4(ncol, nrow))
      meanT4 = 0.0

! Set phantomSeedsOut to zero (initialization)
      phantomSeedsOut = 0.0
