!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

! ------------------------------------------------------------------------------
      SUBROUTINE assimsnow (zonefile)
!     Provides an average array of a value for each zone in zonefile according to
!     a input grid gridfile.
!     Maximum number of zones: 999999
! ------------------------------------------------------------------------------
      use prevahglobals

      INTEGER nprg
      REAL outarr(ntfl,7),ravg,lims,nvali
      DOUBLE PRECISION, allocatable :: zstat2D(:,:),mzones(:,:)
	REAL, allocatable :: valid(:,:)
      INTEGER*4, allocatable :: zones(:,:),zoneslong(:)
      CHARACTER*256 gridfile,zonefile

! ------------------------------------------------------------------------------
!     Read the file to be ...zoned
! ------------------------------------------------------------------------------
      errlab=0
	nprg=0
!	lims=10
!	lims=30
!	lims=18.5
      lims=assimlimit
	outarr=0
	gridfile=assimnam
!	gridfile='D:\projekte\annina\assimil\g_op_20060317.slf'
!	gridfile='D:\projekte\annina\assimil\g_re_20060317.slf'
!	gridfile='D:\projekte\annina\assimil\g_sat_20060317.slf'    ! Clouds and oder special codes not yet accounted

      OPEN (433,FILE=TRIM(gridfile),status='old',form='binary',
     *      err=999)

	uwas=433
	include 'rwasim.inc'
	ALLOCATE (valid(ncol,nrow))
	ALLOCATE (zstat2D(ncol,nrow))
	ALLOCATE(mzones(ncol,nrow))

	include 'rw2Dr.inc'

      DO ycoor=1,nrow
	   nprg=nprg+1
         DO xcoor=1,ncol
	      if (assimsource .eq. 1) then
	      if (write2D(xcoor,ycoor) .eq. 250) write2D(xcoor,ycoor)=0
	      if (write2D(xcoor,ycoor) .eq. 255)
     *           write2D(xcoor,ycoor)=-50
	      end if
	      valid(xcoor,ycoor)=write2D(xcoor,ycoor)
	      zstat2D(xcoor,ycoor)=dble(write2D(xcoor,ycoor))
	      if (write2D(xcoor,ycoor) .eq. rnodat) cycle
!	      if (write2D(xcoor,ycoor) .lt. lims) then
!		  write2D(xcoor,ycoor)=max(0.,write2D(xcoor,ycoor)-lims)
!	      end if
	      valid(xcoor,ycoor)=write2D(xcoor,ycoor)
	      zstat2D(xcoor,ycoor)=dble(write2D(xcoor,ycoor))
         END DO
      END DO
	wstats(1)=0
	wstats(2)=1e8
	wstats(3)=-1e8
	wstats(4)=0
	wstats(5)=0
	wstats(6)=0

!     computing new average
	do ycoor=1,nrow
	do xcoor=1,ncol
        if (valid(xcoor,ycoor) .ge. 0) then
		wstats(1)=wstats(1)+1
		wstats(2)=min(wstats(2),valid(xcoor,ycoor))
		wstats(3)=max(wstats(3),valid(xcoor,ycoor))
		wstats(4)=wstats(4)+valid(xcoor,ycoor)
	  else
	    valid(xcoor,ycoor)=rnodat
	  endif
	end do
	end do


	ravg=wstats(4)/wstats(1)

!	print* ,ravg,ssoma,wstats(4),wstats(1)

      DEALLOCATE(write2D)

! ------------------------------------------------------------------------------
!     Read the zones
! ------------------------------------------------------------------------------

      UNIT=731

      OPEN (731, file=TRIM(zonefile),status='old',form='binary',
     *      err=998)

      uwas=731

      include 'rwasim.inc'
      include 'rw2dr.inc'

      close (731)

      do ycoor=1,nrow
	   nprg=nprg+1


      do xcoor=1,ncol
         mzones(xcoor,ycoor)=dble(write2D(xcoor,ycoor))
      enddo
      enddo

      DEALLOCATE(write2D)

      ALLOCATE(ZONESLONG(ntfl))


      DO I=1,INT(wstats(3))
         ZONESLONG(I)=0.0
      ENDDO

	J=0

      do ycoor=1,nrow
	   nprg=nprg+1
        do xcoor=1,ncol
           if (valid(xcoor,ycoor) .eq. rnodat) then
	     if (sngl(mzones(xcoor,ycoor)) .ne. rnodat) then
           valid(xcoor,ycoor)=-50
	     else
		 cycle
	     end if
	     end if
	     if (sngl(mzones(xcoor,ycoor)) .eq. rnodat) then
		     valid(xcoor,ycoor)=rnodat
			 cycle
	     end if
           J=INT(mzones(xcoor,ycoor))
           ZONESLONG(J)=ZONESLONG(J)+1
        enddo
      enddo



      ALLOCATE (ZONES(ntfl,3))

      J=0

      DO I=1,INT(wstats(3))
          IF (ZONESLONG(I) .ne. 0.) then
              J=J+1
              ZONES(J,2)=ZONESLONG(I)
              ZONES(J,1)=I
              ZONES(J,3)=0.0
          end if
      END DO

      DEALLOCATE (zoneslong)

      do ycoor=1,nrow
	   nprg=nprg+1
         do xcoor=1,ncol
           if (valid(xcoor,ycoor) .eq. rnodat) cycle
           DO I=1,ntfl
 	       outarr(I,4)=1e8
	       outarr(I,5)=-1e8
	       outarr(I,6)=0.
             IF (INT(sngl(mzones(xcoor,ycoor))) .eq.
     * INT(ZONES(I,1))) THEN
               mzones(xcoor,ycoor)=dble(float(I))
             end if
           end do
         enddo
      enddo

! ------------------------------------------------------------------------------

      do ycoor=1,nrow
	   nprg=nprg+1
      do xcoor=1,ncol
         if (valid(xcoor,ycoor) .eq. rnodat) cycle
         J=INT(sngl(mzones(xcoor,ycoor)))
	   outarr(J,4)=min(outarr(J,4),sngl(zstat2D(xcoor,ycoor)))
	   outarr(J,5)=max(outarr(J,5),sngl(zstat2D(xcoor,ycoor)))
	   outarr(J,6)=outarr(J,6)+sngl(zstat2D(xcoor,ycoor))
      enddo
      enddo

	nvali=0
      do J=1,ntfl
         outarr(J,3)=sngl(dble(outarr(J,6))/dble(float(zones(J,2))))
	   outarr(J,1)=float(zones(J,1))
	   outarr(J,2)=float(zones(J,2))
	   if (outarr(j,3) .lt. 0.0) cycle
	   nvali=nvali+float(zones(J,2))
      end do
      ravg=0

	do j=1,ntfl
	   if (outarr(j,3) .lt. 0.0) cycle
	   if (outarr(j,3) .le. lims) then
	   outarr(j,3)=0
	   outarr(j,4)=0
         end if
	   ravg=ravg+outarr(j,3)*zones(J,2)/nvali
!         write (7775,*) j,ravg,outarr(j,3),zones(J,2),ssotf(j)
	end do

      do J=1,ntfl
         if (landin(j) .eq. 1) then
	   ssotf(j)=0
         snowtf(j)=0
	   else
	if (outarr(J,3) .ge. 0) then
         write (7775,*) (j-0.5),(j+0.5),outarr(J,3)/ravg*ssoma

	   if (ravg .gt. 0) ssotf(j)=outarr(J,3)/ravg*ssoma
         if (ravg .gt. 0) ssnowtf(j)=outarr(J,3)/ravg*ssoma
	   if (ssotf(j) .lt. 0.5) snowtf(j)=0
	   if (ssotf(j) .ge. 0.5) snowtf(j)=1
	end if

	end if
      end do

      DEALLOCATE (zstat2D,zones,mzones,valid)
      goto 1000
998   CONTINUE
      DEALLOCATE (zstat2D,mzones,valid)
999   CONTINUE
1000  CONTINUE
	RETURN

      END
