!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE DATTAE (DAT,TAGA,TAGE,MONA,MONE,JAHRA,JAHRE,
     *                   DKAL,DSUM)

!     This subroutine computes the lenght of the model run basing on
!     the date of begin (TAGA,MONA,JAHRA) and end date (TAGE,MONE,JAHRE)
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      INTEGER DAT,TAGE,TAGA,MONE,MONA,JAHRE,JAHRA,DKAL,DSUM

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------
      INTEGER TA,MO,JA,ID,I,J,IHG
      REAL RHG
      DIMENSION DAT(12)

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

! ---------------------------------------------------------------------
!     Lenght of month and leap year are accounted
! ---------------------------------------------------------------------

      DAT(1)=31
      DAT(2)=28
      DAT(3)=31
      DAT(4)=30
      DAT(5)=31
      DAT(6)=30
      DAT(7)=31
      DAT(8)=31
      DAT(9)=30
      DAT(10)=31
      DAT(11)=30
      DAT(12)=31

      RHG=JAHRA/4.0

      IHG=INT(RHG+0.01)

      IF (RHG.GT.IHG) GOTO 1

      DAT(2)=29

1     TA=TAGA
      MO=MONA
      JA=JAHRA
      DSUM=1

      IF (JAHRE.LT.JA) GOTO 4
      IF ((JAHRE.EQ.JA).AND.(MONE.LT.MO)) GOTO 4
      IF ((JAHRE.EQ.JA).AND.(MONE.EQ.MO).AND.(TAGE.LE.TA)) GOTO 4

2     CONTINUE
      TA=TA+1
      DSUM=DSUM+1

	IF ((TA.EQ.TAGE).AND.(MO.EQ.MONE).AND.(JA.EQ.JAHRE)) GOTO 4

      IF (TA.LE.DAT(MO)) THEN
      GOTO 2
	ELSE
! Testing if end of simulation is placed at first day of a month
	ta=1
	MO=MO+1
      IF ((TA.EQ.TAGE).AND.(MO.EQ.MONE).AND.(JA.EQ.JAHRE)) GOTO 4
	MO=MO-1
	END IF

      TA=1
      MO=MO+1

      IF (MO.LE.12) GOTO 2

      DAT(2)=28

      MO=1
      JA=JA+1

      IF ((TA.EQ.TAGE).AND.(MO.EQ.MONE).AND.(JA.EQ.JAHRE)) GOTO 4

      RHG=JA/4.0
      IHG=INT(RHG+0.01)

      IF (RHG.GT.IHG) GOTO 2

      DAT(2)=29
      GOTO 2

4     CONTINUE

      DAT(2)=28

      RHG=JAHRA/4.0
      IHG=INT(RHG+0.01)

      IF (RHG.GT.IHG) GOTO 6

      DAT(2)=29

6     ID=DAT(2)

      DKAL=TAGA
      IF (MONA.LE.1) GOTO 10
      J=MONA-1
      DO 8 I=1,J
      DKAL=DKAL+DAT(I)

8     CONTINUE

10    CONTINUE

      DAT(2)=ID

      RETURN

      END
! ---------------------------------------------------------------------
!     Subroutines and functions to determinate the day of week
      subroutine gtojdn(jdn,dd,m,y,ier)
C Julian Day number (used in astronomy) NOTE REAL*8
C Input: dd,m,y
C Output: jdn
      implicit integer (a-z)
      real*8 jdn
      ier=0
      if(m.le.2) then
         y1=y-1
         m1=m+12
      else
         y1=y
         m1=m
      endif
      if((y.eq.1582.and.m.ge.10.and.dd.ge.15) .or.
     & (y.gt.1582)) then
         A=INT(y1/100)
         B=2-A+INT(A/4)
      else
         B=0
      endif
      if(y1.le.0) then
         C=INT((365.25d0*y1)-0.75d0)
      else
         C=INT(365.25d0*y1)
      endif
      D=INT(30.6001d0*(m1+1))
      JDN=B+C+D+dd+1720994.5d0+0.5d0
      return
      end

      subroutine DOW (d,m,y,ier,idow)
C Given day month year find day of week
C 0=sun etc.
      implicit integer (a-z)
	integer idow,ier
      real*8 A,jdn,rdow
      call gtojdn(jdn,d,m,y,ier)
      A=(jdn+1.5)/7
      rdow=(A-int(A))*7
	idow=int(sngl(rdow))
      return
      end
