!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE EJULIANZ (JAHR,MONAT,TAG,JULIANDATUM)


C Computes the julian date since 1.1.1900. The julian date of 1.1.1901 366.
! ---------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
	INTEGER TAG,MONAT,JAHR	              ! day, month year
      INTEGER JULIANDATUM                     ! julian date

! ---------------------------------------------------------------------
!     Local variables
! ---------------------------------------------------------------------

      INTEGER MONATSLAENGE(12)                ! lenght of the months
      INTEGER I                               ! loop variable

      DATA MONATSLAENGE /31,28,31,30,31,30,31,31,30,31,30,31/

!  365 Days per year

      JULIANDATUM=365*(JAHR-1900)

! every fourth year is leap
      JULIANDATUM=JULIANDATUM+(JAHR-1900)/4

! add the lenght of the past months
      IF (MONAT.NE.1) THEN
        DO 1 I=1,MONAT-1
          JULIANDATUM=JULIANDATUM+MONATSLAENGE(I)
    1   CONTINUE
      ENDIF

! correct first and second month if leap year

      IF ((MOD(JAHR-1900,4).EQ.0).AND.(MONAT.LE.2)) THEN
        JULIANDATUM=JULIANDATUM-1
      ENDIF

! add the current day in the current month
      JULIANDATUM=JULIANDATUM+TAG

! ---------------------------------------------------------------------

      RETURN
      END
