!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

! writes grids for monthly output

      write(CHJA ,'(I4)')JAHR

      CALL CHARNR (MON,CHMO)

      DO I=1,21

        IF (whgrid(I)(3:3) .EQ. 'N') CYCLE
        IF (whgrid(I)(3:3) .EQ. 'n') CYCLE
         namgrd=diroutput(1:posi3)//
     *   idnam(posiid1:posiid2)//CHJA//CHMO//'mm'//ergrid(I)

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else

         IF (I .EQ. 1) WRGRD(xcoor,ycoor)=PAKMS(xcoor,ycoor)

         IF (I .EQ. 2) WRGRD(xcoor,ycoor)=EPMS(xcoor,ycoor)

         IF (I .EQ. 3) WRGRD(xcoor,ycoor)=ERMS(xcoor,ycoor)

         IF (I .EQ. 4) WRGRD(xcoor,ycoor)=EIMS(xcoor,ycoor)

         IF (I .EQ. 5) WRGRD(xcoor,ycoor)=EBMS(xcoor,ycoor)

         IF (I .EQ. 6) WRGRD(xcoor,ycoor)=RGEMS(xcoor,ycoor)

         IF (I .EQ. 7) WRGRD(xcoor,ycoor)=R0MS(xcoor,ycoor)

         IF (I .EQ. 8) WRGRD(xcoor,ycoor)=R1MS(xcoor,ycoor)

         IF (I .EQ. 9) WRGRD(xcoor,ycoor)=R2MS(xcoor,ycoor)

         IF (I .EQ. 10) WRGRD(xcoor,ycoor)=GLACMS(xcoor,ycoor)

         IF (I .EQ. 12) WRGRD(xcoor,ycoor)=WSAMS(xcoor,ycoor)

         IF (I .EQ. 13) WRGRD(xcoor,ycoor)=GWNBMS(xcoor,ycoor)

         IF (I .EQ. 14) then
		 WRGRD(xcoor,ycoor)=SSOTF(xcoor,ycoor)
		 if (WRGRD(xcoor,ycoor) .lt. 1.) WRGRD(xcoor,ycoor)=0.
		 End If

         IF (I .EQ. 15) WRGRD(xcoor,ycoor)=SITF(xcoor,ycoor)

         IF (I .EQ. 16) WRGRD(xcoor,ycoor)=SSMTF(xcoor,ycoor)

         IF (I .EQ. 17) WRGRD(xcoor,ycoor)=SUZTF(xcoor,ycoor)

         IF (I .EQ. 18) WRGRD(xcoor,ycoor)=SLZTF(xcoor,ycoor)

         IF (I .EQ. 19) WRGRD(xcoor,ycoor)=SLZ1TF(xcoor,ycoor)

         IF (I .EQ. 20) WRGRD(xcoor,ycoor)=snowdaystf(xcoor,ycoor,1)

         IF (I .EQ. 21) WRGRD(xcoor,ycoor)=
     *          (SFCTF(xcoor,ycoor)-fsad_tf(xcoor,ycoor,6)/24/
     *          MONUM(MON))/SFCTF(xcoor,ycoor)

		end if
	end do
	end do


        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'

	    IF (I .eq. 21) then
         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.smdeficit'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=fsad_tf(xcoor,ycoor,6)/MONUM(MON)/24
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'
	end if

! FORHYCS Output
	    IF (I .eq. 15) then
         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.rlai_phen'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=forhycs(xcoor,ycoor,1)
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'

         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.simax'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=forhycs(xcoor,ycoor,2)
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'
	end if

! Final snow ablation day, output in september

	    IF ((I .eq. 20) .and. (mon .eq. 9)) then

         namgrd=diroutput(1:posi3)//idnam(posiid1:posiid2)//
     *   CHJA//CHMO//'mm.snowdays'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
               WRGRD(xcoor,ycoor)=snowdaystf(xcoor,ycoor,1)-
     *         snowdaystf(xcoor,ycoor,2)
         snowdaystf(xcoor,ycoor,2)=snowdaystf(xcoor,ycoor,1)
		end if
	end do
	end do
        OPEN (732,FILE=namgrd,STATUS='unknown',ERR=999,FORM='BINARY')
        uwas=732
	include 'wstsp.inc'

	do ycoor=1,nrow
	do xcoor=1,ncol
         if (int(gezg(xcoor,ycoor)) .eq. int(rnodat)) then
		 WRGRD(xcoor,ycoor)=rnodat
		 cycle
		else
	    fsad_tf(xcoor,ycoor,1)=0
	    fsad_tf(xcoor,ycoor,2)=0
	    fsad_tf(xcoor,ycoor,3)=273
	    fsad_tf(xcoor,ycoor,4)=0
	    fsad_tf(xcoor,ycoor,5)=0
		end if
	end do
	end do
		END IF

      END DO
