!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

       SUBROUTINE IDAT10M (JAHR,NKZ,ERRA,digiext,dirin)

!     Defines and opens the files with meteorological input at the beginning of
!     each year
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

      INTEGER JAHR,                                ! year
     *        IRGL,                                ! controls number of files that have to be opened
     *        ERRA,                                ! error flag
     *        digiext,                              ! number of digits in the extension, 2 or 4
     *        nkz
      CHARACTER*256 FILEN,dirin                        ! file names 1

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------

      INTEGER I,L,POS
      CHARACTER*256 NAMED
      CHARACTER*56 ZEIK
      CHARACTER*2 JZ
      CHARACTER*4 YYYY
! ---------------------------------------------------------------------

      I=0

	CALL POSNAM (dirin,1,POS)
190   CONTINUE

!     Defines the files names for the current year

      ERRA=0

	if (digiext .eq. 2) THEN
      CALL CHARNR (JAHR,JZ)
      FILEN=dirin(1:pos)//'10min.s'//JZ
	end if

	if (digiext .eq. 4) THEN
      WRITE (YYYY,'(I4)') JAHR
      FILEN=trim(dirin)//'10min.s'//YYYY
	end if

!    Open the file
      CLOSE (1234)
      OPEN (1234,FILE=FILEN,STATUS='OLD',err=999)
	print* ,trim(filen)

7     FORMAT (A56)
      IF (NKZ.GT.0) THEN
      DO L=1,NKZ
         READ (1234,7) zeik                  ! Reads the headers
      END DO
      ENDIF
      GOTO 194

999   ERRA=1
194   CONTINUE

! ---------------------------------------------------------------------

      RETURN
      END
