!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

       SUBROUTINE IDATKLIM (JAHR,NKZ,IRGL,MDATN,FILENA,FILEN,ERRA,
     *                     digiext,rmet,TAGA,MONA,ANFS,NTG,
     *                     NDTD,TAGE,MONE,JAHRE,I)!,reps)

!     Defines and opens the files with meteorological input at the beginning of
!     each year
!--------------------------------------------------------------------------
      use realtime
      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

      INTEGER JAHR,IJAHR,                          ! year
     *        NKZ,                                 ! number of headers in the file
     *        IRGL,                                ! controls number of files that have to be opened
     *        MDATN(6),                            ! ID number for up to 6 files
     *        ERRA,                                ! error flag
     *        digiext,reps(6)                      ! number of digits in the extension, 2 or 4
      CHARACTER*256 FILEN(6),                       ! file names 1
     *        FILENA(6)                            ! file names 2
	CHARACTER*1 rmet(6)

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------

      INTEGER I,L,POS,yyaval(202),mclim,ai,mdcli
	REAL sjj
      CHARACTER*256 NAMED
      CHARACTER*56 ZEIK
      CHARACTER*2 JZ
	CHARACTER*4 YYYY

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

      INTEGER TI,			    ! Time step
     *        TAG,			! Actual day
     *        MON,			! Actual month
     *        ANFS,			! Starting column for readin input information
     *        NTG,			! Number of meteorological zones
     *        NDTD,			! number of time steps
     *        MDR,			! pointer to the log-file
     *        MBI,			! pointer to to prompt
     *        TAGE,			! end day
     *        MONE,			! end month
     *        JAHRE			! end year

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------

      INTEGER TAGI,ITAGA,TAGA,			! begin day
     *        MONI,MONA,			! begin month
     *        JAHRI,			! begin year
     *        JAR,			! help parameter for year
     *        J,K,p,r,jjjc	    ! parameters for loops
	! Read values
      REAL, ALLOCATABLE :: READVAL(:,:)
      REAL, ALLOCATABLE :: climsum(:)
	LOGICAL*4 EXISTFILE

! ---------------------------------------------------------------------

!     makes climatology file if RMET = c or C

      if ((rmet(I) .eq. 'y') .or. (rmet(I) .eq. 'Y')
     *     .or. (rmet(I) .eq. 'G')) RETURN
      sjj=0
      do ijahr=1900,2100
	yyaval(ijahr-1899)=0
	if (ijahr .eq. jahr) cycle

!     Defines the files names for the current year
      ERRA=0
	CALL POSNAM (FILENA(I),1,POS)
      NAMED=FILENA(I)(1:POS)
      WRITE (YYYY,'(I4)') ijahr
      FILEN(I)=NAMED(1:POS) //'.s'//YYYY

	mclim=ijahr
!    Open the file
      OPEN (mclim,FILE=FILEN(I),STATUS='OLD',err=194)
      yyaval(ijahr-1899)=1
	sjj=sjj+yyaval(ijahr-1899)
7     FORMAT (A56)
      IF (NKZ.GT.0) THEN
      DO L=1,NKZ
         READ (mclim,7) zeik                  ! Reads the headers
      END DO
      ENDIF

      cycle
194   CONTINUE
	END DO

	if (sjj .le. 1) return
	rmet(I)='C'

!     Starting computation of climatology
      FILEN(I)=NAMED(1:POS) // '.sclim'


!    Open the file
      mdcli=MDATN(I)
      close (mdcli)
      OPEN (mdcli,FILE=FILEN(I),STATUS='UNKNOWN')!,form='binary')
      Call messagerun (2,'Computing climatology ....')
      L=ANFS+NTG-1

      ALLOCATE (READVAL(202,L))
	itaga=taga
      IF ((29.EQ.TAGA).AND.(2.EQ.MONA)) itaga=28


	do ijahr=1900,2100


	if (yyaval(ijahr-1899) .eq. 0) cycle

      ai=ijahr-1899

73    CONTINUE
      mclim=ijahr
      READ (mclim,*,end=997) JAR,MONI,TAGI,TI,(READVAL(ai,K),K=1,L)

!     Search entry date
      IF ((TAGI.EQ.ITAGA).AND.(MONI.EQ.MONA)) THEN
	backspace (mclim)
	CYCLE
      ELSE
	goto 73
      END IF
	end do

74    continue
!     Making climatology
      ALLOCATE (climsum(L))
	do k=1,l
      climsum(k)=0.
	end do
	do ijahr=1900,2100

      ai=ijahr-1899

	if (yyaval(ai) .eq. 0) cycle
      mclim=ijahr
      do k=1,l
      READVAL(ai,k)=0
	end do
75    continue

      READ (mclim,*,end=997) JAR,MONI,TAGI,TI,(READVAL(ai,K),K=1,L)

      IF ((29.EQ.TAGI).AND.(2.EQ.MONI)) goto 75

      do p=1,l
	climsum(p)=climsum(p)+READVAL(ai,p)/sjj
	end do

	end do
!
      jjjc=9999
      write (mdcli,'(4I6,999(F))') jjjc,MONI,TAGI,TI,
     * (climsum(K),K=1,L)

	deallocate (climsum)

      IF ((MONI.ne.MONE).OR.(TAGI.ne.TAGE)) GOTO 74
	IF (JAHR .ne. JAHRE) GOTO 74
 997  continue
	Call messagerun (2,'Done ....')
	do ijahr=1900,2100
      mclim=ijahr
	close (mclim)
	end do
	close (mdcli)
	OPEN (mdcli,FILE=FILEN(I),STATUS='OLD')!,form='binary')
! ---------------------------------------------------------------------
      deallocate (readval)
      RETURN
998   continue
	CALL POSNAM (FILENA(I),1,POS)
      NAMED=FILENA(I)(1:POS)
      mdcli=MDATN(I)
      close (mdcli)
      FILEN(I)=NAMED(1:POS) // '.sclim'
	OPEN (mdcli,FILE=FILEN(I),STATUS='OLD')!,form='binary')

	return
      END
