!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

       SUBROUTINE IDATNAM (JAHR,NKZ,IRGL,MDATN,FILENA,FILEN,ERRA,
     *                     digiext,rmet,ntg,ntgid)

!     Defines and opens the files with meteorological input at the beginning of
!     each year
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

      INTEGER JAHR,                                ! year
     *        NKZ,                                 ! number of headers in the file
     *        IRGL,                                ! controls number of files that have to be opened
     *        MDATN(6),                            ! ID number for up to 6 files
     *        ERRA,                                ! error flag
     *        digiext                              ! number of digits in the extension, 2 or 4
      CHARACTER*256 FILEN(6),                       ! file names 1
     *        FILENA(6)                            ! file names 2
	CHARACTER*1 rmet(6)

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------

      INTEGER I,L,POS,J,ntg,ntgid(999)
      CHARACTER*256 NAMED
      CHARACTER*5600 ZEIK
      CHARACTER*2 JZ
	CHARACTER*4 YYYY
! ---------------------------------------------------------------------

      I=0

190   CONTINUE

      I=I+1

	IF (I .gt. 6) goto 194
!     open file if RMET = y or Y
      if ((rmet(I) .ne. 'g') .and. (rmet(I) .ne. 'G')) GOTO 190

!     Defines the files names for the current year

      ERRA=0
	CALL POSNAM (FILENA(I),1,POS)
      NAMED=FILENA(I)(1:POS)

      FILEN(I)=NAMED(1:POS) // '_full.stats'



!    Open the file
      OPEN (MDATN(I),FILE=FILEN(I),STATUS='unknown',err=999)
	write (mdatn(I),'(A)')

     *   'YYYY MM DD        MIN        MAX        AVG      STDEV'

      IF (I .LT. 6) GOTO 190

      GOTO 194

999   ERRA=1
194   CONTINUE
! ---------------------------------------------------------------------

      RETURN
      END
