!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!     Initialization of model parameters

      CRSZ=0.0
      CU=0.35
      K3H=0.0
      K3=0.0
	  K2=0
	  K0=0
	  K1=0
      CG1H=0.0
      CG2H=0.0
      CG3H=0.0
      SLZ1MAX=0.0
      CEXLIQ=2.0
      HELA=0
      CICEMF=0.0
      CAICE=0.0
      CSNOMF=0.0
      CASNO=0.0
      ISNOGL=0
      KICEH=0.0
      KICSH=0.0
      KICFH=0.0
      TICEH=0
      TICSH=0
      TICFH=0
      CLN=ALOG(1.0-K0)
      K0H=(-1.0)/CLN
      CLN=ALOG(1.0-K1)
      K1H=(-1.0)/CLN
      CLN=ALOG(1.0-K2)
      K2H=(-1.0)/CLN
      TTRANS=1.0

	  DO I=1,256
	  DO J=1,6
	  FILENA(J)(I:I)=' '
	  filen(J)(I:I)=' '
	  END DO
	  DO J=1,9
	  effinams(9)(I:I)=' '
	  END DO
	  DO J=1,99
	  routnams(99)(I:I)=' '
	  ENDDO
	  namshdh(I:I)=' '
	  rknam(I:I)=' '
	  savenam(I:I)=' '
	  loadnam(I:I)=' '
	  idnam(I:I)=' '
	  routeffnam(I:I)=' '
	  gkwfile(I:I)=' '
	  namgrd(I:I)=' '
	  dirstate(I:I)=' '
	  dirmeteo(I:I)=' '
	  diroutput(I:I)=' '
	  nadgkw(I:I)=' '
	  namaus(I:I)=' '
	  namlog(I:I)=' '
	  NAMDRU(I:I)=' '
      NAMTAG(I:I)=' '
      NAMMON(I:I)=' '
      NAMHOU(I:I)=' '
      NAMSTD(I:I)=' '
      NAMQ(I:I)=' '
      NAMTMP(I:I)=' '
      NAMMIT(I:I)=' '
      NAMLOG(I:I)=' '
	  END DO



      DO i=1,999
          ntgfl(i)=1
          aetg(i)=0.0
          atg(i)=0.0
          PNKTG(i)=0.0
          PAKTG(i)=0.0
          WSATG(i)=0.0
          EPTG(i)=0.0
          ERTG(i)=0.0
          EITG(i)=0.0
          EBTG(i)=0.0
          R0TG(i)=0.0
          R1TG(i)=0.0
          R2TG(i)=0.0
          RGETG(i)=0.0
          SSMTG(i)=0.0
          SSOTG(i)=0.0
          SITG(i)=0.0
          SSZTG(i)=0.0
          SUZTG(i)=0.0
          SLZTG(i)=0.0
      ENDDO

      DO i=1,24
          PNKHM(i)=0.0
          PAKHM(i)=0.0
          WSAHM(i)=0.0
          EPHM(i)=0.0
          ERHM(i)=0.0
          EIHM(i)=0.0
          EBHM(i)=0.0
          R0HM(i)=0.0
          R1HM(i)=0.0
          R2HM(i)=0.0
		  RGB1HM(i)=0.0
		  RGB2HM(i)=0.0
		  RGB3HM(i)=0.0
          RGEHM(i)=0.0
          SSMHM(i)=0.0
          SSOHM(i)=0.0
          SIHM(i)=0.0
          SUZHM(i)=0.0
          SLZHM(i)=0.0
          RGDTI(i)=0.0
          SDDTI(i)=0.0
          PAKT(i)=0.0
          PNAKT(i)=0.0
          HFICE(i)=0.0
          HFICS(i)=0.0
          HFICF(i)=0.0
          SHADTI(i)=0.0
      ENDDO
