!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa, J. Schwanbeck

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

	SUBROUTINE lake_p_et

! ---------------------------------------------------------------------
! Generates special output for lakes:
! Rlake = P - ET (precipitation on lake surface and potential evapotranspiration from surface of the lake)
!
! # Jan Schwanbeck <jansc@gmx.net>
! # Hydrology Group / Dept. of Geography, University of Berne
!
! VER 0.1, Build 22.04.2008
! ---------------------------------------------------------------------
!     Common Variables - prevahglobals.for
! ---------------------------------------------------------------------
	  USE			prevahglobals

      implicit none

!     real			aelhg	!-> expected catchment area (readpins.inc)
!     character*1   xmlyn	!-> xml output y/n
!     integer	    MDQ		!->
!     integer		MDSTD	!->
!     real          pnkhm(24),pakhm(24),wsahm(24),ephm(24),erhm(24),rgehm(24)
! ---------------------------------------------------------------------
!     Formats
! ---------------------------------------------------------------------
101   FORMAT (  I4,3(X,I2),6(X,F8.3) )
102   FORMAT (  I4,3(X,I2),X,F9.5,X,F11.2,X,6F9.5,X,F11.2,X,I5)
! ---------------------------------------------------------------------
!     Begin Processing
! ---------------------------------------------------------------------
	  rgehm(i) = pakhm(i)-ephm(i) ! lakes water balance Pcorr-ETpot (JS-2008-04)
      WRITE (MDSTD,101) jahr,mon,tag,i,pnkhm(i),pakhm(i),wsahm(i),ephm(i),erhm(i),rgehm(i)
	  WRITE (MDQ,102) jahr,mon,tag,i,rgehm(i), rgehm(i)*AELHG/(3.6)

      IF (xmlyn.EQ.'Y') CALL xmlwrite

! ---------------------------------------------------------------------
!     End Processing
! ---------------------------------------------------------------------
      RETURN
	ENDSUBROUTINE
!*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
