!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2003 Joachim Gurtz, Massimiliano Zappa
! Modifications copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa,
! Marc Scherstjanoi, Heike Lischke
! 2014 - 2018: Inclusion of FORHYCS variables

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------


! set variables to zero at model initialization

      PNKSM=0.0
	  PAKSM=0.0
	  WSASM=0.0
	  EPSM=0.0
	  ERSM=0.0
	  EISM=0.0
	  EBSM=0.0
	  R0SM=0.0
	  R1SM=0.0
	  R2SM=0.0
	  RGESSM=0.0
	  SSOM=0.0
	  SIM=0.0
	  SSMM=0.0

	   PNKDS=0.0
       TEDS=0.0
       RLDS=0.0
       SDDS=0.0
       WVDS=0.0
       RGDS=0.0

	    frost_tf=0
	    fsad_tf=0
	    fsad_tf=0
	    fsad_tf=273
	    fsad_tf=0
	    fsad_tf=0
          nrtgfl=1
          aetfl=0.0
          atfl=0.0
          faspect=0.0
          fslope=0.0
          fbfeucht=0.0
          fbtyp=0
          fkwert=0
          vkwert=0.0
          fbtief=0
          ftopi=0.0
          fbtopi=0.0
          sitf=0.0
          ssotf=0.0
          ssnowtf=0.0
          sliqtf=0.0
          ssztf=0.0
          suztf=0.0
          slztf=0.0
          slz1tf=0.0
          slz2tf=0.0
          slz3tf=0.0
          ssmtf=0.0
          bil=0.0
          snowtf=0
          mtf=0
		  snowdaystf=0
		  snowdaystf=0
          rafi=0.0
          rafipar=0.0
          TEDM=0.0
          RLDM=0.0
          WVDM=0.0
          PNKS=0.0
          PAKS=0.0
          WSAS=0.0
          EPS=0.0
          ERS=0.0
          EIS=0.0
          EBS=0.0
          R0S=0.0
          R1S=0.0
          R2S=0.0
          RGESS=0.0
          GWNBS=0.0
          GWNBMS=0.0
          GWNBJS=0.0
          glacS=0.0
          glacMS=0.0
          glacJS=0.0
          emtf=0.0
          snowen=0.0
          surfsnot=273.16
          SICETF=0.0
          SICSTF=0.0
          SICFTF=0.0
             SHADTFL=0.0
             SHADETFL=0.0
             HTFICE=0.0
             HTFICS=0.0
			 gglm=0
			 gezg=0


      !Marc's LAI stuff
       gdd5=0.0
       chilldays=0.0
       dtemp31=0.0
       mtemp=0.0
       sen_day_count=0.0
       aphen=0.0
       oldphen=0.0
       forhycs=0.0
       spcgdd0=-1.0
       ddegsum5=0.0
       ddegsum5old=0.0
       muwint=0.0
       drstr=0.0
	drstr2=0.0
	meant=0.0
       sump=0.0
	meantold=0.0
       sumpold=0.0
       meantC = 0.0
       meantCOld = 0.0
       drstrold=0.0
	drstrold2=0.0
       fhla=0.0

       perCC = 0.0  ! Matthias Jul 2015

       ! Matthias' glacier stuff
       minSnowCover = 0.0

       drydays = 0
       eIntMS = 0.0
       eSnowMS = 0.0
       eSoilMS = 0.0
       eTransMS = 0.0
       petMS = 0.0
       peSoilMS = 0.0
       peTransMS = 0.0
       eWaterMS = 0.0
       eIntJS = 0.0
       eSnowJS = 0.0
       eSoilJS = 0.0
       eTransJS = 0.0
       petJS = 0.0
       eWaterJS = 0.0
       peSoilJS = 0.0
       peTransJS = 0.0

       simaxtf = 0.0


       qsmon = 0.0
       qsyr = 0.0
       qlmon = 0.0
       qlyr = 0.0
       qgmon = 0.0
       qgyr = 0.0

       relSSD = 0.0

       lcChange = 0.0

       compBioClim = 0.0

       siuTF = 0.0
       siumaxTF = 0.0

       flai = 0.0
       vh100 = 0.0
       vh99 = 0.0
       vh95 = 0.0

       meanTOut = 0.0
       sumPOut = 0.0

       rgs2d = 0.0
       prec2d = 0.0
       pt2d = 0.0
       at2d = 0.0
       pes2d = 0.0
       aes2d = 0.0
       int2d = 0.0
       esn2d = 0.0
       enf2d = 0.0

       gsLength = rnodat
       gsTpot = rnodat
       gsPrec = rnodat
       gsPrecDays = rnodat
       gsTemp = rnodat
       gsPes = rnodat
       gsPe = rnodat

       gsLengthCur = 0.0
       gsTpotCur = 0.0
       gsPrecCur = 0.0
       gsPrecDaysCur = 0.0
       gsTempCur = 0.0
       prevDayP = 0
       gsPeCur = rnodat

       eeqrmean = 0.0
       pefrmean = 0.0

       dstr30 = rnodat
       gdd30 = rnodat
       curhcmax = 60  ! Dummy value to initialize site- and species-dependent max height

       gsDMI = 0.0

       !Schill = 0.0
       !Sforcing = 0.0
       !doyBB = -1
       !doySen = -1
       !meanT4 = 0.0

       ssen3d = 0.0
       doysen = 0

       rsmin2d = 0.0

       deltaBio = rnodat
