!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------


      SUBROUTINE ODATKGEW (NUGEB,AE,AELHG,IART,DT,NTFL,
     *           NTG,NTGFL,AETG,ATG,LANGWSF,KURZWSF,VFEUCHTF,
     *           TAGA,MONA,JAHRA,TAGE,MONE,JAHRE,GEOBREITE,
     *           ZG,ZN,CLANG,CKURZ,CVENT,ZEIKE,ZEIPM,MDRU )

!     This subroutine writes information of the model run into the logfile
! ---------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Variables
! ---------------------------------------------------------------------
      INTEGER MDRU,NUGEB,IART,NTFL,NTG,NTGFL(999)
      INTEGER TAGA,MONA,JAHRA,TAGE,MONE,JAHRE
      INTEGER LANGWSF,KURZWSF,VFEUCHTF
      INTEGER I,K,L,IFE(999)
      INTEGER IYR,IMONT,IDAY,IHR,IMIN
      REAL DT,AE,AELHG,GEOBREITE,AETG(999),ATG(999)
      CHARACTER*56 ZEIKE,ZEIPM(6)
      CHARACTER*31 CKURZ(17),CLANG(10),CVENT(3)
      CHARACTER*32 ZG,ZN

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------
1     CONTINUE
129   FORMAT ( '  ' )
130   FORMAT (/,'  Programm PREVAH  ETHZ-Version 2.0  -  June/2003',
     *        /,'  ==================================================',
     *        /)
131   FORMAT (  '                     LOG-FILE                 '  )
132   FORMAT ( / )
133   FORMAT (  '            File including daily values       '  )
159   FORMAT (  '            File including hourly values      '  )
135   FORMAT (  '            File including monthly values     '  )

      WRITE (MDRU,130)
      IF (MDRU .EQ. 42) WRITE (MDRU,131)
      IF (MDRU .EQ. 8 ) WRITE (MDRU,133)
      IF (MDRU .EQ. 9 ) WRITE (MDRU,135)
      IF (MDRU .EQ. 11) WRITE (MDRU,159)

134   FORMAT ('    PREVAH was run on ',i2,'.',i2,'.',i4,
     *        ' at  ',i2,':',i2)
c      CALL GETDAT (IYR,IMONT,IDAY)
c      CALL GETTIM (IHR,IMIN,ISEC,I100TH)
      iday=8
      imont=8
      iyr=2003
      ihr=8
      imin=30
      WRITE (MDRU,134) iday,imont,iyr,ihr,imin
      write (MDRU,'('' '')')

136   FORMAT ( 1X,A56)
138   FORMAT (  ' Catchment designation      : ',A32,
     *        /,' Gauge name                 : ',A32,
     *        /,' Catchment identifier       : ',I7   )
140   FORMAT (  ' Total catchment area       : ',F7.2,' km**2 (=AE) ',
     *        /,' Mapper area                : ',F7.2,' km**2 (=AELHG)'
     *          )
142   FORMAT (  ' Sub-catchemtns         TG  : ',I5,
     *        /,' Number of HRUs         TFL : ',I5   )
143   FORMAT (  ' TG-Nr.                     : ',10I5 )
144   FORMAT (  ' Number of HRUs             : ',10I5 )
156   FORMAT (  ' Partial areas      .(km**2): ',10F5.1 )
158   FORMAT (  ' Portion of area      TG (%): ',10F5.1 )
146   FORMAT (  ' Latitude (deg)             : ',F7.2,' deg ' )
148   FORMAT (  ' Time step-DT               : ',F7.1,' Hour(s)' )

      DO 150 I=1,NTG
         IFE(I)=I
150   CONTINUE
      WRITE (MDRU,138) ZG,ZN,NUGEB
      WRITE (MDRU,140) AE,AELHG
      WRITE (MDRU,142) NTG,NTFL
      L=1
      K=NTG
      IF (NTG .GT. 10) K=10
      WRITE (MDRU,143) (IFE(I),I=L,K)
      WRITE (MDRU,144) (NTGFL(I),I=L,K)
      WRITE (MDRU,156) (AETG(I),I=L,K)
      WRITE (MDRU,158) (ATG(I),I=L,K)
      IF (NTG .GT. 10) THEN
         L=11
         K=NTG
         IF (NTG .GT. 20) K=20
         WRITE (MDRU,143) (IFE(I),I=L,K)
         WRITE (MDRU,144) (NTGFL(I),I=L,K)
         WRITE (MDRU,156) (AETG(I),I=L,K)
         WRITE (MDRU,158) (ATG(I),I=L,K)
      ENDIF
      IF (NTG .GT. 20) THEN
         L=21
         K=NTG
         IF (NTG .GT. 30) K=30
         WRITE (MDRU,143) (IFE(I),I=L,K)
         WRITE (MDRU,144) (NTGFL(I),I=L,K)
         WRITE (MDRU,156) (AETG(I),I=L,K)
         WRITE (MDRU,158) (ATG(I),I=L,K)
      ENDIF
      IF (NTG .GT. 30) THEN
         L=31
         K=NTG
         WRITE (MDRU,143) (IFE(I),I=L,K)
         WRITE (MDRU,144) (NTGFL(I),I=L,K)
         WRITE (MDRU,156) (AETG(I),I=L,K)
         WRITE (MDRU,158) (ATG(I),I=L,K)
      ENDIF
      WRITE (MDRU,146) GEOBREITE
      WRITE (MDRU,148) DT
      WRITE (MDRU,129)
      WRITE (MDRU,136) ZEIKE
      L=IART+1
      WRITE (MDRU,136) ZEIPM(L)
      write (MDRU,'('' Estimation of LW-Rad   '',a)') clang(langwsf+1)
      write (MDRU,'('' Estiamtion of SW-Rad   '',a)') ckurz(kurzwsf+1)
      write (MDRU,'('' Aereodynamic-term      '',a)')cvent(vfeuchtf+1)

154   FORMAT (  ' Investigated time range    : ',i2,'.',i2,'.',i4,' - ',
     *          i2,'.',i2,'.', i4 )

      WRITE (MDRU,154) TAGA,MONA,JAHRA,TAGE,MONE,JAHRE

! ---------------------------------------------------------------------
      RETURN
      END
! ---------------------------------------------------------------------
