!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE ODATTFDI (NRTF,AETFL,ATFL,NRTGFL,
     *           BTYP,FKWERT,HOEHE,ASPECT,SLOPE,BFEUCHT,
     *           FNFC,FBTIEF,FCK,ZBTYP,ZKWERT,CLAND, MDRU )

!     This subroutine writes the phisiographic properties of each
!     HRU into the logfile
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      INTEGER MDRU,
     *        NRTF,                                      ! number of HRUs
     *        NRTGFL(NRTF)                               ! ID of each HRU
      INTEGER BTYP,                                      ! soil type
     *        FKWERT(NRTF)                               ! category of field capacity
      REAL AETFL(NRTF),                                  ! HRU area (km2)
     *        ATFL(NRTF),                                ! HRU area %
     *        FNFC(NRTF),                                ! Avail.-field capacity [Vol%]
     *        FBTIEF(NRTF),                              ! Soil depth [m]
     *        FCK(NRTF),                                 ! hydr. conductivity [mm/h]
     *        HOEHE,                                     ! Average elevation[m a.s.l.]
     *        BFEUCHT,                                   ! Soil moisture at initialization [mm]
     *        ASPECT,                                    ! Aspect (N=0-360 deg)
     *        SLOPE                                      ! Slope (deg)
      CHARACTER*40 ZBTYP(3),ZKWERT(3),CLAND

! ---------------------------------------------------------------------
!     Local Variables
! ---------------------------------------------------------------------
      INTEGER  I

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------


129   FORMAT (  '  ' )
146   FORMAT (  ' HRU number                 : ',I4,
     *        /,' HRU area                   : ',F7.2,' km**2 ',
     *        /,' Portion to total area      : ',F7.2,' % ' )
147   FORMAT (  ' Belongs to meteo unit nr.  : ',I4  )
148   FORMAT (  ' HRU properties             :',A  )
150   FORMAT (  ' Average elevation          : ',F7.2,' m a.s.l.')
152   FORMAT (  ' Aspect (N=0-360 deg)       : ',F7.2,' deg ',
     *        /,' Slope (deg)                : ',F7.2,' deg ',
     *        /,' Avail.-field capacity      : ',F7.2,' Vol% ',A,
     *        /,' Soil depth                 : ',F7.2,' m    ',
     *        /,' Class of hydr. conductivity: ',E7.1,' mm/h ',A,
     *        /,' Soil moisture at initializ : ',F7.2,' mm '  )

      WRITE (MDRU,129)
      WRITE (MDRU,146) NRTF,AETFL(NRTF),ATFL(NRTF)
      WRITE (MDRU,147) NRTGFL(NRTF)
      WRITE (MDRU,148) CLAND
      WRITE (MDRU,150) HOEHE
      I=FKWERT(NRTF)
      WRITE (MDRU,152) ASPECT,SLOPE,FNFC(NRTF),ZBTYP(BTYP),
     *                 FBTIEF(NRTF),FCK(NRTF),ZKWERT(I),BFEUCHT

! ---------------------------------------------------------------------
      RETURN
      END
