!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      subroutine pardistread

	use prevahglobals
	use MPIVars, only: rank, root, doParallel

      implicit none

	character*256 rfile


      distparnam(14)='KRIG_CAICE.bin'
      distparnam(10)='KRIG_CG1H.bin'
      distparnam(13)='KRIG_CICEMF.bin'
      distparnam(12)='KRIG_CPERC.bin'
      distparnam(7)='KRIG_K0H.bin'
      distparnam(8)='KRIG_K1H.bin'
      distparnam(9)='KRIG_K2H.bin'
      distparnam(1)='KRIG_PKORF.bin'
      distparnam(5)='KRIG_RMFSNOW.bin'
      distparnam(6)='KRIG_SGRLUZ.bin'
      distparnam(11)='KRIG_SLZ1MAX.bin'
      distparnam(2)='KRIG_SNOKOR.bin'
      distparnam(3)='KRIG_T0.bin'
      distparnam(4)='KRIG_TMFSNOW.bin'

!	NADGKW='F:\cchydro\databases\parameters\basins\Lim200'


      do npu=1,14
      rfile=trim(adjustl(NADGKW))//'-'//trim(adjustl(distparnam(npu)))


	open (8111, file=trim(rfile), status='old',
     *     form='binary', err=1999)


	uwas=8111
!	dayval=0

	INCLUDE 'rwasim.inc'

	if (npu .eq. 1) then
	allocate(distpar(14,ncol,nrow))
	allocate(abfdist(4,ncol,nrow))
	end if

      do ycoor=nrow,1,-1
          read (uwas) (distpar(npu,xcoor,ycoor),xcoor=1,ncol)
      end do

	close (uwas)

      if((rank==root).or.(doParallel==.false.)) print*, trim(rfile)

      do ycoor=nrow,1,-1
	do xcoor=1,ncol

! ------------------------------------------------------------------------------
! Transformation of storage coefficient from hours to exponential factor


      abfdist(1,xcoor,ycoor)=0.0
      IF (distpar(7,xcoor,ycoor) .GT. 0.0) abfdist(1,xcoor,ycoor)=1.0-
     *  EXP(-1.0/distpar(7,xcoor,ycoor))
      abfdist(2,xcoor,ycoor)=0.0
      IF (distpar(8,xcoor,ycoor) .GT. 0.0) abfdist(2,xcoor,ycoor)=1.0-
     *  EXP(-1.0/distpar(8,xcoor,ycoor))
      abfdist(3,xcoor,ycoor)=0.0
      IF (distpar(9,xcoor,ycoor) .GT. 0.0) abfdist(3,xcoor,ycoor)=1.0-
     *  EXP(-1.0/distpar(9,xcoor,ycoor))
      k3=0.0
      abfdist(4,xcoor,ycoor)=0.11111*distpar(9,xcoor,ycoor)

	END DO
	end do

	end do

112   CONTINUE

      RETURN


1999  CONTINUE


! ---------------------------------------------------------------------

      print*, 'File Not Found ',trim(rfile)

      STOP

!      RETURN
      END
