!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE PARMEX1 (FPAR,PARMAX,PARMIN,PARMIT)

!     This subroutine computes maximum, minimum and average of an array
!     The partial contibution of each HRU is weighted by it portion with
!     respect to the total area of a catchment
! ---------------------------------------------------------------------

      use prevahglobals

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      REAL    PARMAX,                              ! maximum of the parameter
     *        PARMIN,                              ! minimum of the parameter
     *        PARMIT,                              ! average of the parameter
     *        FPAR(ncol,nrow),                           ! parameter
     *        lopa

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

      PARMAX=-10000000.
      PARMIN=10000000.
      PARMIT=0.0

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(fpar(xcoor,ycoor)) .eq. int(rnodat)) cycle
	   lopa=fpar(xcoor,ycoor)
         PARMIT=PARMIT+lopa
         IF (lopa .GT. PARMAX) PARMAX=lopa
         IF (lopa .LT. PARMIN) PARMIN=lopa
      END DO
	END DO

	parmit=parmit/wstats(1)

!      print*, PARMIT,PARMAX,PARMIN

! ---------------------------------------------------------------------

      RETURN
      END
