!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE PARMEXL (PARMAXL,PARMINL,PARMITL) !FPAR,VFPAR,

!     This subroutine computes maximum, minimum and average of the logarithm
!     of an array. The partial contibution of each HRU is weighted by
!     its portion with respect to the total area of a catchment
! ---------------------------------------------------------------------

      use prevahglobals

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

      REAL    PARMAXL,                              ! maximum of the parameter
     *        PARMINL,PARLMIT,                      ! minimum of the parameter
     *        PARMITL                              ! average of the parameter
!     *        FPAR(ncol,nrow),                           ! parameter
!     *        VFPAR(ncol,nrow)                           ! parameter

!      REAL FPARL(ncol,nrow)                ! log of FPAR
      REAL PAR,PARMIT,PARMAX,PARMIN,lopa

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

      print*, 'ok'

      PARMAXL=-1000.
      PARMINL=1000.

      PARMITL=0.0
      PARLMIT=0.0
      PARMAX=-1000000.
      PARMIN=1000000.
      PARMIT=0.0

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(FCK(xcoor,ycoor)) .eq. int(rnodat)) cycle
	   lopa=FCK(xcoor,ycoor)
         PARMIT=PARMIT+lopa
         IF (lopa .GT. PARMAX) PARMAX=lopa
         IF (lopa .LT. PARMIN) PARMIN=lopa
      END DO
	END DO

	parmit=parmit/wstats(1)

      IF ((PARMIT .EQ. 0.0) .or. (PARMIN .EQ. 0.0)) THEN
         PARMITL=0.0
         PARMAXL=0.0
         PARMINL=0.0
!         VFPAR=0.0
         GOTO 10
      ENDIF

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(FCK(xcoor,ycoor)) .eq. int(rnodat)) cycle
	   lopa=FCK(xcoor,ycoor)
         IF (lopa .LE. 0.0) THEN
            VKWERT(xcoor,ycoor)=ALOG(PARMIN)
           ELSE
            VKWERT(xcoor,ycoor)=ALOG(lopa)
         ENDIF
         IF (VKWERT(xcoor,ycoor) .LE. PARMINL)
     *  PARMINL=VKWERT(xcoor,ycoor)
      ENDDO
	END DO

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(FCK(xcoor,ycoor)) .eq. int(rnodat)) cycle
         VKWERT(xcoor,ycoor)=VKWERT(xcoor,ycoor)-PARMINL+1.0
         VKWERT(xcoor,ycoor)=EXP(VKWERT(xcoor,ycoor))
      ENDDO
	END DO

      PARMINL=1000.0

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(FCK(xcoor,ycoor)) .eq. int(rnodat)) cycle
        if(fck(xcoor,ycoor) == maxval(fck)) cycle
	   lopa=alog(VKWERT(xcoor,ycoor))
         PARMITL=PARMITL+lopa
         IF (lopa .GT. PARMAXL) PARMAXL=lopa
         IF (lopa .LT. PARMINL) PARMINL=lopa
      ENDDO
	END DO

      PARMITL=PARMITL/wstats(1)
      !print*, "PARMEXL", PARMITL,PARMAXL,PARMINL, wstats(1), maxval(fck)

10    CONTINUE

! ---------------------------------------------------------------------

      RETURN
      END
