!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2003 Joachim Gurtz, Massimiliano Zappa
! Modifications copyright (C) 2014-2018  Matthias Speich, Massimiliano Zappa,
! Marc Scherstjanoi, Heike Lischke
! 2014 - 2018: Inclusion of new variables for FORHYCS coupling and MPI
! parallel execution

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Module contaiing all global variables in PREVAH
!-------------------------------------------------------------------------------

	module prevahglobals

      use realtime
! -------------------------------------------------------------------
      integer tistep,ier
	character*256 ernam,gknam,namein,diroutput,locnam
	character*256 gken
	character*1 docali,doeff
	character*3 gkext(99)
! -------------------------------------------------------------------
      integer langwsf,kurzwsf,vfeuchtf,snoest,btyp,nrgeb,hoehtg(999)
      integer iyr,imont,iday,ihr,imin,isec,i100th,k,kk,i,j,y,l,nj,jk,POS
      integer tag,taga,tage,mon,mona,mone,itag,imon,debug,ihg,lnrg
      integer jahr,jahra,jahre,ijahr,tsa,tsu,irgl,nkz,nrk,istk,igst
      integer mta,mbi,mdr,mdtag,mdmon,mdstd,mdtmp,mdmit,midat,mdgkw,mlog
      integer :: mcatch, pcatch, ecatch1, ecatch2, ecatch3, ecatch4,
     *      ecatch5, ecatch6, ecatch7
      integer, allocatable :: catchID(:), catchSize(:)
      integer dat(12),m,mdat6,mdhou,mdq,mhtml,mfcast,mdbull
      integer mdatn(6),idrust,ibild,MSHDH
      integer dtd,ndtd,ndjahr,idruck,iart,ds,dsum,dkal,ierg,snow,erra
      integer ntfl,nugeb,ntg,ntgfl(999),ntgid(999)
      integer, allocatable :: nrtfl(:,:),nrtgfl(:,:),fkwert(:,:)
      integer, allocatable :: fbtyp(:,:),landin(:,:)
	integer, allocatable :: regio(:,:),gezg(:,:)
      integer, allocatable :: snowtf(:,:),mtf(:,:),scatch(:,:)
	integer, allocatable :: gglm(:,:), mezgrid(:,:)
	real, allocatable :: rglm(:,:) ! Matthias
	integer, allocatable :: mtdmask(:,:) !Matthias
	integer, allocatable :: catch(:,:) !Matthias
      integer land,jar,jahrk,ti,nof,njahr,mpri,anfs
      integer shadst,posi1,posi2,posi3,posi4,posi5,posi6
	integer posiid1,posiid2,cbopt,unit,subcamax
	character*6 :: catchAbbr ! Matthias

! ------------------------------------------------------------------------------

      real dt,datum,ae,hoehe,geobreite,slope,aspect,aeber,aelhg,aeges
      real anffc,cln,qga
      real aegrid,gwnbds,glacds,glacss,glacmm,glacjj,glactt
	real firnds, mfirn
	real gwnbjsm,gwnbsm,erice,prldifga
      real pnktg(999),paktg(999),wsatg(999),eptg(999),ertg(999)
      real eitg(999),ebtg(999),r0tg(999),r1tg(999),r2tg(999),rgetg(999)
      real ssmtg(999),ssotg(999),sitg(999),suztg(999),slztg(999)
      real ssztg(999),pnkhm(24),pakhm(24),wsahm(24),ephm(24),erhm(24)
      real eihm(24),ebhm(24),r0hm(24),r1hm(24),r2hm(24),rgehm(24)
	real rgb1hm(24),rgb2hm(24),rgb3hm(24),rgb1dm,rgb2dm,rgb3dm
      real ssmhm(24),ssohm(24),sihm(24),suzhm(24),slzhm(24),difgadm
	real hsuzhm(72),hslzhm(72)
 !     real pndt(24,999),tedt(24,999),rgdt(24,999),rldt(24,999)
 !     real wvdt(24,999),sddt(24,999),
      real rldti(24),pndti(24),rgdti(24),sddti(24),tedti(24),wvdti(24)
      real aetg(999),atg(999),runsubca(24,999)
	real areasubca(9999),outsubca(9999),nsubca(9999)
	real dadm,tedad,rldad

      real, allocatable :: teds(:),rlds(:),treemig_array(:,:,:)
      real, allocatable :: aetfl(:,:),atfl(:,:),wvds(:),vkwert(:,:)
      real, allocatable :: gwnbs(:,:),gwnbms(:,:),gwnbjs(:,:),glacs(:,:)
      real, allocatable :: glacms(:,:),glacjs(:,:),rgdm(:,:),tedm(:,:)
      real, allocatable :: rgds(:),rldm(:,:),wvdm(:,:),sdds(:,:)
      real, allocatable :: epms(:,:),erms(:,:),eims(:,:),r0js(:,:)
	real, allocatable :: ebms(:,:),eps(:,:),ers(:,:),wsams(:,:)
      real, allocatable :: epjs(:,:),erjs(:,:),eijs(:,:),ebjs(:,:)
      real, allocatable :: eis(:,:),ebs(:,:),r0s(:,:),r1s(:,:)
      real, allocatable :: r1ms(:,:),r1js(:,:),r2s(:,:),r2ms(:,:)
      real, allocatable :: slz3tf(:,:),r0ms(:,:),wsajs(:,:),pnkms(:,:)
      real, allocatable :: rgems(:,:),rgejs(:,:),rgess(:,:),bil(:,:)
      real, allocatable :: wsas(:,:),pnkjs(:,:),pakjs(:,:),paks(:,:)
	real, allocatable :: pnkds(:,:),r2js(:,:),slz1tf(:,:)
      real, allocatable :: pakms(:,:),pnks(:,:),ssotf(:,:),ssnowtf(:,:)
      real, allocatable :: sliqtf(:,:),sitf(:,:),ssztf(:,:),slz2tf(:,:)
      real, allocatable :: ssmtf(:,:),sfctf(:,:),suztf(:,:),slztf(:,:)
      real, allocatable :: fnfc(:,:),fck(:,:),fbtief(:,:),ftopi(:,:)
      real, allocatable :: fbtopi(:,:),sicetf(:,:),sicstf(:,:)
      real, allocatable :: sicftf(:,:),htfice(:,:,:),htfics(:,:,:)
	real, allocatable :: htficf(:,:,:),frost_tf(:,:)
      real, allocatable :: shadtfl(:,:,:),shadetfl(:,:,:),fsad_tf(:,:,:)
      real, allocatable :: fsad_old(:,:,:)
      real, allocatable :: fhoehe(:,:),fslope(:,:),snowdaystf(:,:,:)
      real, allocatable :: faspect(:,:),fbfeucht(:,:),rtrasl(:)
      real, allocatable :: pndtg(:,:,:),tedtg(:,:,:),rgdtg(:,:,:)
      real, allocatable :: wvdtg(:,:,:),sddtg(:,:,:),rldtg(:,:,:)
      real, allocatable :: whc(:,:)  ! Soil water holding capacity
      real, allocatable :: flai(:,:)  ! LAI as calculated by TreeMig + phenology
      real, allocatable :: rgs2d(:,:) ! Grid containing daily runoff values - for catchment-integrated results
      real, allocatable :: prec2d(:,:) ! Grid containing daily precip values - for catchment-integrated results
      real, allocatable :: pt2d(:,:)
      real, allocatable :: at2d(:,:)
      real, allocatable :: pes2d(:,:)
      real, allocatable :: aes2d(:,:)
      real, allocatable :: int2d(:,:)
      real, allocatable :: esn2d(:,:)
      real, allocatable :: enf2d(:,:)

! Standard land cover-dependent parameters
      real, dimension(30,12) :: stdLai, stdZveg, stdRSmin, stdVfrac,
     *  stdSImax, stdZRoot
      real, dimension(30) :: WHCsf, stdAlb



      real hfice(24),hfics(24),hficf(24)
	real ricehm(24),ricshm(24),ricfhm(24),wicehm(24)
      real pnksm,paksm,wsasm,epsm,ersm,eism,ebsm,r0sm,r1sm,r2sm,rgessm
      real pnkjsm,pakjsm,wsajsm,epjsm,erjsm,eijsm,ebjsm,r0jsm,r1jsm
      real pnkmsm,pakmsm,wsamsm,epmsm,ermsm,eimsm,ebmsm,r0msm,r1msm
      real r2msm,rgemsm,r2jsm,rgejsm,slz1,slz2,slz3,ssz
      real ssotb,sitb,ssmtb,suztb,slztb,perc
      real sso1500(2,2)
      real ssom,sim,ssmm,suzm,slzm,ssod,sid,ssmd,suzd,slzd,gebil,atflk
      real pds,pnds,precmin,sso,ssnow,sliq,wsa,wsb,pakt(24),pnakt(24)
      real asec,ssm,sfc,sgrlp,suz,slz,albas,da,ssoma
      real bfeucht,rhg,ssdmx,rglmx,vbga,aseca
      real wurzelv(12),vbgf(12),simaxf(12),epvdt(24)
      real albadd,albaddd,gt,g0
      real awacv(12),awsolv(12),nfcap,btief,prl,r
      real r0,r1,r2,r3,rges,rgeds,rl,etra,epdt,eidt,esnodt,eskdt,ebdt
      real cg2h,rg1,rg2,rg3
      real topi,btopi,topmax,topmin,topmit,kwert,kwmitl,kwmaxl,kwminl
      real ssd,tec,rgl,wiv,rlf,bn,ebds,erds,epds,eids,r0ds,r1ds,r2ds
      real pakds,wsads,ssob,sib,ssmb,suzb,slzb,si,epbdt
      real verdunstung,raa,rss,et,edsu,erdt,fehl,x1,x7
      real ct,sice,sics,sicf
      real rice,rics,ricf,wice,wics,wicf,teck,rgk,rdm,rdmk,rices,rice3
      real tekdti(24),shadti(24),rgkdti(24),rgmdti(24)
      real rgmkdti(24),rdmdti(24),rdmkdti(24),ssdmax
      real tecdm,tekdm,ssdds,shadm,rgdam,rgkdm,rgmdm,rdmdm,rgmkdm,rdmkdm
	real translation(99),storage(99)

! AWC restricted and unrestricted by land use
      real, allocatable :: sfcg(:,:),  awcg(:,:)

! Taken out of prevahglobals:

! Local vegetation & land cover params
      real rlai,bhoehe,fluxabsorb,rsc,albedo,awac,awacsol,vbg,simax
      real rlai12(12),bhoehe12(12),flux12(12),albedo12(12),rsc12(12)


! ------------------------------------------------------------------------------

      character*1  ipdat,ipna,dorout,tcali
      character*4  turn , form4
      character*8  zpar , behoe , zpar5
      character*8  zdim,  zdim5
      character*256 rknam,climfile,namshdh
	character*15 zierg,gcode
      character*256 nadgkw,namaus,filena(6),filen(6),filenr(6),namlog,
     *              namdru,namtag,nammon,namstd,nammit,namtmp,
     *              namhou,namq,namcatch,namprec,
     *    namev1, namev2, namev3, namev4, namev5, namev6, namev7
      character*32 zn,zg,zvarna(6)
      character*40 zland(30),zbtyp(3),zkwert(3),cland,cbtyp
      character*48  z
      character*56  zeipm(6),zeike
      CHARACTER*78 kopf
      character*31 ckurz(17),clang(10),cvent(3)
      CHARACTER*30 MODUL(20)
	CHARACTER*512 messtext

! ---------------------------------------------------------------------
!     Tuneable parameters
! ---------------------------------------------------------------------

      INTEGER HELA,				! Can define the equilibrium line altitude of a glacier
     *        ISNOGL,				! Variable to control the snowmelt computation
!			if ISNOGL = 0 computation after positive degree day index of combination method
!				  = 1 Hock on glaciated areas with constant melt factor
!				  = 2 Hock on glaciated areas with varying melt factor
!				  = 3 Hock everywhere with constant melt factor
!				  = 4 Hock everywhere with varying melt factor
!				  = 5 Hock everywhere with constant melt factor, only if sunny day (no precipitation)
!				  = 6 Hock everywhere with varying melt factor, only if sunny day (no precipitation)
     *        TICEH,				! Translation time for icemelt
     *        TICSH,				! Translation time for snowmelt
     *        TICFH				! Translation time for firn melt

      REAL PKORF,pkorf_bp,			! adjustment of rainfall %
     *     SNOKOR,snokor_bp,			! adjustment of snowfall %
     *     CREDV,				! reduction factor - vegetated - unvegetated areas

! For snowmelt module
     *     TGR,					! treshold temperature snowfall
     *     TTRANS,				! transition temperature snow-rain
     *     T0,					! treshold temperature snowmelt
     *     CRMFMAX,				! maximal temperature-index melting factor
     *     CRMFMIN,				! minimal temperature-index melting factor
     *     CWU1,				! melting factor by wind 1
     *     CWA2,				! melting factor by wind 2
     *     CWH,					! retention factor for melting snow
     *     CEXLIQ,				! exponent for retention of melting snow
     *     CRFR,				! coefficien for re-freezin if Air temperature < 0 �C
     *     CSNOMF,				! constant temperature melt factor for snow
     *     CASNO,				! constant radiation melt factor for snow

!for runoff-generation module
     *     CBETA,    			! non linearity parameter for inflitration module
     *     CU,					! treshold of ssm/ssmax (0..1) for reducin ETP
     *     CRSZ,				! 0..1 maximal percentage of total runoff that is generated by surface runoff
     *     SGRLUZ,				! treshold coefficient for surface runoff
     *     CPERC,				! Percolation rate
     *     K0H,					! Storage coefficient in hours for surface runoff
     *     K0,					! Storage coefficient for surface runoff as exponent
     *     K1H,					! Storage coefficient in hours for interflow
     *     K1,					! Storage coefficient for interflow as exponent
     *     K2H,					! Storage coefficient in hours for baseflow
     *     K2,					! Storage coefficient for delayed baseflow as exponent
     *     CG1H,				! Storage coefficient in hours for quick basflow
     *     SLZ1MAX,				! Maximal content of the quick baseflow storages SLZ1
     *     CG3H,				! 1/9 of CG1H after Schwarze
     *     K3H,					! Storage coefficient in hours for karst flow (not active)
     *     K3,					! Storage coefficient for karst flow as exponent (not active)
     *     DSUZ,                  ! Runoff generation in current time step

! for icemelt module
     *     CICEMF,				! constant temperature melt factor for ice
     *     CAICE,				! constant radiation melt factor for ice
     *     KICEH,				! Coefficient for runoff generation from ice storage in hours
     *     KICSH,				! Coefficient for runoff generation from snow storage in hours
     *     KICFH				! Coefficient for runoff generation from firn storage in hours

! ------------------------------------------------------------------------------
!    ESCIMO -> see escimo subroutine for the declaration of the variables
      real phase,ssdr,vap,vaps,ssoa,kondens
      real qs,ql,pliq,psnow,emtfr,a0,apos,aneg
      real, allocatable :: snowen(:,:),surfsnot(:,:)
      real, allocatable :: emtf(:,:)
      real energy,surftemp,ssdhs,albhh(24)
! ------------------------------------------------------------------------------
!    PIKUL
      real soilt,sensflux,glkofa
      real, allocatable ::   soiltp(:,:),sensiflux(:,:)
! ------------------------------------------------------------------------------
!    Distributed parameters
       real, allocatable ::   distpar(:,:,:),abfdist(:,:,:)
       real fixpkorf,fixsnokor,fixperc,fixsgrluz
       real fixt0,fixicet,fixicer,fixsnow
       character*256 distparnam(14)
	logical pardist
	integer npu
! ------------------------------------------------------------------------------
!    Regional and monthly adjustment of rainfall and snowfall
      real snomokor(12),remokor(12),regskor(999),regrkor(999)
      integer precmokor,lann,snowupdate
      character*6 snowdat(50),datsnow
! ------------------------------------------------------------------------------
!    Grid Ausgabe

	INCLUDE 'wasim.h'
      real class,caglt,cagls,shdfkt,shdj,ustar
      INTEGER LN,opnssm,beg
      REAL FAK
      REAL, allocatable :: XX(:,:,:),wrgrd(:,:)
      character*7 whgrid(25) ! Matthias: changed length of ERGRID and WHGRID from 21 to 25
      character*4 ergrid(25)
      character*256 idnam,routeffnam
	character*256 gkwfile,namgrd,dtctrfil,messrun
      CHARACTER dpunkt*1,grdakt*1
      CHARACTER*2 CHMO,CHTA,CHHH
      CHARACTER*4 CHJA
! ------------------------------------------------------------------------------
!     Load and Save state
      character*256 dirstate,dirmeteo
      character*1 LOADID,SAVEID,SAVEMMID,SAVEMOREID,ZK
      character*8 LOADCHAR,DATUMCHAR,DATUMCHARO,LOADROUT
      character*8, allocatable :: savechar(:)
      character*256 savenam,loadnam,effinams(9),routnams(99)
	character*72 gebmet
      integer SAVEMORENN,nn,ii,digiext,mdstate
      integer, allocatable ::SAVEDD(:),SAVEMM(:), SAVEYY(:)
      INTEGER dtmin(6),neffis,TOPT,RHOPT,zst,nrouts,monum(12)
      CHARACTER*1 ST,zk1,rmet(6),szaktiv
	logical isice,upforest

! ------------------------------------------------------------------------------
!     Forecast from file
      integer fortype,fordays,fordt(6),fnext,forensemble,fordummy
	integer fordate(99,4),rainshape(99,4,24),tshape(99,24),qtime
	integer hoursb,hourse,iee,ibb,reps(6),allit,stp,ltrasl
	real    forrain(99,3,24),fortemp(99,3,24),shapecoeffs(3,24)
	real    forrad(99,24),forsuns(99,24),forrelh(99,24),forwind(99,24)
	real    rgsensemble(9,99,24),allinf,tampli(99,24)
	real    lastrunoff, scalerain,scaleslz,rainensemble(24),runoffbias
	real    prainsum,rqtime,ferror,cliadjust(6),fbasp

! ------------------------------------------------------------------------------
!    Ten minutes split of rain
      real tenval(24,6),sixval(6)
      character*1 rsplit
! ------------------------------------------------------------------------------
!    HRU Output
      integer numohru,idnumhru(99),llhru,poshru

! ------------------------------------------------------------------------------
!    Random fields
      real, allocatable :: rafi(:,:),rafipar(:,:)
	real ravar,raerg(12,31,100),ravarar(100)
	integer raopt,rapars,ranloop
	real ramin(9),ramax(9),raminn(9),ramaxx(9)
! ------------------------------------------------------------------------------
!    Hydro Powr Plants
      integer hpprules,dayofweek
	real hppfill(9),hpptake(9),giveatday(7),giveathour(24)
	real hppelev,hppexp,hppcoef
	double precision hppstorage,hppbegin,hppadd(24),hppstormax
	double precision hppsumt,hppgive
	logical isstor,lbulletin

! ------------------------------------------------------------------------------
! Assimilation procedure
      logical doassim
	integer assimopt,assimsource,assimdate(3),nassim
	real assimlimit
	character*256 assimnam

! ------------------------------------------------------------------------------
!    Internal sub basins (JS-2008-04)
      logical isbyn		! internal sub basin y/n
      character*256 isbpath	! directory and filename of grid.isb
	character*256 NAMISBQ   ! file name of outputfile (*.qsb)
	integer MIDH			! i/o - variable defined in init.inc
	integer MISB			! i/o - variable defined in init.inc
	integer MISBQ			! i/o - variable defined in init.inc
	integer validcells		! number of valid cells in gridmaps
	integer numisb			! number of internal sub basins

	integer, allocatable :: isb (:), idh(:) ! values from grid maps
	real, allocatable :: qisb (:,:), areaisb(:) ! discharge and area for each internal sub basin

! ------------------------------------------------------------------------------
!    Xml output (JS-2008-04)
      character*1 xmlyn	   ! xml output y/n
      character*256 xmlpath  ! directory and filename of xml output-file
      character*32 gaugeid   ! Id (or No.) of gauge (pref. LHG-No.) or catchment
      character*256 runname  ! name of the simulation
      integer MXML		   ! i/o - variable defined in init.inc
      logical lastmultirun   ! indicates last run in multiple run mode; final line of xml-file can be written

! ------------------------------------------------------------------------------
!    lake handling (JS-2008-04)
      logical islake     ! if .true., than the catchment is a lake and special output will be generated
      real    rlake(24)	 ! rlake = Pcorr - ETpot

! ------------------------------------------------------------------------------
! Deltachange scenarios
      logical deltachange
	character dodelta*1,filedelta*256,cleangrid*1,iceyy*4,cleansleep*1
       character forestyy*4
	character deltavar(6),deltamethod(6)
	integer deltayy,deltaloop,currentdeltayy,cdatn(6),deltayye,yyice
       integer yyforest
      real cpndt(12,31),ctedt(12,31),crgdt(12,31),crldt(12,31)
      real cwvdt(12,31),csddt(12,31)
	real CPRL,CTEKDM,CRGMKDM,CRGMKDTI,CWIV,CRLF
	real CTECK,CPAKT(24),CTEC,trmlaiforest

! ------------------------------------------------------------------------------

! ------------------------------------------------------------------------------
! Dr. Thomas "Eddy" W�hling - Updating procedure
! September-October 2005
! ------------------------------------------------------------------------------
	REAL uptol,QmesDat(24),upfac(24),jnmeas(24),fixmmup
	INTEGER firstuph,fixhhup,updt
	character*1 updatejn, ausgabejn
	character*256 obsqnam
	logical douptol
	LOGICAL jnDatei
! ------------------------------------------------------------------------------
! Variables for ET partitioning
      integer, allocatable :: drydays(:,:)
      real, allocatable :: eIntMS(:,:), eSnowMS(:,:), eSoilMS(:,:),
     *  eTransMS(:,:), petMS(:,:),eWaterMS(:,:),
     *  eIntJS(:,:),eSnowJS(:,:),eSoilJS(:,:), eTransJS(:,:),
     *  petJS(:,:),eWaterJS(:,:),peSoilMS(:,:),
     *  peTransMS(:,:), peSoilJS(:,:),peTransJS(:,:)

      real, allocatable :: simaxtf(:,:) ! Dynamically parameterized SIMAX

! Grids of radiation budgets
      real, allocatable :: qsmon(:,:), qsyr(:,:), qlmon(:,:), qlyr(:,:),
     * qgmon(:,:), qgyr(:,:)

      real, allocatable :: relSSD(:,:)

! Output of monthly mean temperature and precip sums for driving BioClim/TreeMig
      real, allocatable :: meanTOut(:,:,:), sumPOut(:,:,:)

! ------------------------------
! REFERENCES
!   Gruber, S. (2007, in press): MTD: a mass-conserving algorithm to parameterize
!   gravitational transport and deposition processes using digital elevation models
!   Water Resources Research.
!
!   Gruber, S. & Peckham, S. (2007, in press): Land surface parameters and objects
!   specfic to hydrlogy. In: Geomorphometry: concepts, software, applications,
!   edited by: Hengl, T. & Reuter, H., JRC, Ispra, Italy.
!
!   Gruber, S., Huggel, C. & Pike, R. (2007, in press): Modeling mass movements and
!   landslide susceptibility using geomorphometry. In: Geomorphometry: concepts,
!   software, applications, edited by: Hengl, T. & Reuter, H., JRC, Ispra, Italy.
!
! MODIFICATION HISTORY:
!   Created by Stephan Gruber (2005-2007)
!
!    Fortran M_Zappa, WSL, June 2010
! ------------------------------
	REAL slp_lim,gamma,dep_lim,imid,imad
      real, allocatable ::   dmax2d(:,:)
      integer, allocatable ::   dir2D(:,:)

      integer, allocatable:: mtdOrder(:,:)
      integer :: numNonNA
      real, allocatable :: transout(:,:), transoutM(:,:,:)
      integer :: mtdfh
! ------------------------------------------------------------------------------

 ! TEMPORARY (Matthias - Jan 2015): get daily mass balance of glaciers
      integer :: countGlac, countglacL
	integer, allocatable :: glacmask(:,:) ! For mass balance
      real :: glacpd, glaced, glacqd, glacdssd, glacdsid, glacdsmd,
     * glacdsuzd, glacdslzd, glacbild, glacdmtd
      real :: glacpy, glacey, glacqy, glacdssy, glacdsiy, glacdsmy,
     * glacdsuzy, glacdslzy, glacbily
      real, allocatable:: tempsnow(:,:), glacbily2d(:,:), MTDbil(:,:)

! Grids for transient glacier update
      real, allocatable :: sGlac(:,:),  ! Ice stored per glacier cell (mm water eq.)
     *                     bedrock(:,:), ! Bedrock topology
     *                     iceFrac(:,:)  ! Fraction of ice cover
      integer, allocatable :: glacID(:,:)

      integer :: glacSwitch  ! Transient glacier module? (0:no, 1:yes)

      integer :: fixssd

	end module prevahglobals

! ------------------------------------------------------------------------------

	module multglob
	integer mbegindays, menddays,imad,imid
	integer mbeginmonths, mendmonths
	integer mbeginyears, mendyears
	character*256 mdiro,fclimate
	character*1 meff,mload,mclim,mrmet(9)
	logical mmult
	end module

! ------------------------------------------------------------------------------
! Transiente parametern

	module transglob
      logical dotransient
	real tppi(2),tpbeta(2),tpk0h(2),tpsgrluz(2),tpexp
	end module
