!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------


      subroutine prevahmeteo

	use prevahglobals
      use MPIVars  ! For testing
      use mpi

      implicit none


846   continue
! ------------------------------------------------------------------------------
      fbasp=0
!     Reading precipitation

	stp=1

!	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (24,dtmin(stp),stp,jahr,
!     *                       mon,tag,dirmeteo,filenr(stp),mdatn(stp),
!     *                       gebmet,cleangrid,diroutput)

	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (pnkds,pndtg,24,
     * dtmin(stp),filenr(stp),mdatn(stp))

!     Reading air temperature:
!     TOPT = option for temperature. Unit: 1=Celsius, 2(not tested)=Kelvin, 3(not tested)=Fahrenheit
      stp=2
	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (tedm,tedtg,24,
     * dtmin(stp),filenr(stp),mdatn(stp))


! Reading global radiation
	stp=3

	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (rgdm,rgdtg,24,
     * dtmin(stp),filenr(stp),mdatn(stp))

! Reading/computing relative humidity
!     RHOPT = option for humidity: Unit: 1=Water vapour pressure in hPA, 2=relative Humidity [0..1],
!       3(not tested)=dewpoint temperature [�C]   4(not tested)=dewpoint temperature [�K]
!       5(not tested)=dewpoint temperature [�F]
	stp=4
	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (rldm,rldtg,24,
     * dtmin(stp),filenr(stp),mdatn(stp))
! Reading wind speed
	stp=5
	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (wvdm,wvdtg,24,
     * dtmin(stp),filenr(stp),mdatn(stp))

! Reading sunshine duration
	stp=6
	if (rmet(stp) .eq. 'G') CALL GIMETDTMIN (sdds,sddtg,24,
     * dtmin(stp),filenr(stp),mdatn(stp))

! MPI_BARRIER necessary here?

      if((rank.ne.root).or.(doParallel==.false.)) then

        call TOPTRHOPT (topt,rhopt,RLDTG,RLDM,TEDTG,TEDM,
     *                       ncol,nrow,24,rnodat)
!       call SSDTOPHH (PNDTG,PNKDS,SDDS,ncol,nrow,24,rnodat)
      end if

      IF (ERRA .EQ. 1) GOTO 999		! if error


!  daily mean of meteorological input is computed for each GRID CELL
	RHG=NDTD*1.0

847   continue
      return
999   continue

      call messagerun (1, 'Error in Meteorological Files')
	stop

	end
