!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------


      subroutine prevahwrite

	use prevahglobals

      implicit none

143    FORMAT (  I2,I5,I4,I8,11F7.0,6F7.1  )
188   FORMAT ( ' K-J-NRTGFL(K)-AETFL(K)-AETG(J)-RHG ',3I4,4F6.2 )

!     Balance for all HRUs
      include 'hrubil.inc'

      IHG=INT((DSUM/365.0)+0.5)
      IF (IHG .LE. 0) IHG=1
      R=IHG*1.0
148   FORMAT ( ' Tot',I4,I4,I8,11F7.0,5F7.1  )

!	Writing grids for period averages
       IF (GRDAKT .EQ. 'Y') THEN
           INCLUDE 'grid.inc'
       ENDIF

!	Writing to monthly tables output
       K=0
      IF ((ZIERG(13:13) .EQ. 'y') .OR. (ZIERG(13:13) .EQ. 'Y'))
     * WRITE (MDMON,148) NRGEB,K,NUGEB,PNKSM/R,PAKSM/R,WSASM/R,
     *                   EPSM/R,ERSM/R,EISM/R,EBSM/R,R0SM/R,R1SM/R,
     *                   R2SM/R,RGESSM/R,
     *                   SSOM,SIM,SSMM,SUZM,SLZM

      IF ((ZIERG(7:7) .EQ. 'y') .OR. (ZIERG(7:7) .EQ. 'Y'))
     * WRITE (MDR,143) NRGEB,K,K,NUGEB,PNKSM/R,PAKSM/R,WSASM/R,
     *                 EPSM/R,ERSM/R,EISM/R,EBSM/R,R0SM/R,R1SM/R,
     *                 R2SM/R,RGESSM/R,
     *                 SSOM,SIM,SSMM,SUZM,SLZM,GLACTT/R

181    FORMAT (   I2,I5,I4,I6,F7.1,10F7.0,5F7.1  )
182    FORMAT ( ' Tot TG',I4,I6,12F7.0,5F7.1  )
183    FORMAT ( I5,1X,I8,1X,7(F7.0,1X),3(F6.1,1X),1X,I5)
184    FORMAT ( / )

      IF ((ZIERG(13:13) .EQ. 'y') .OR. (ZIERG(13:13) .EQ. 'Y'))
     * WRITE (MDMON,184)

! Writing statistics from the different meteorological zones
        DO 186 K=1,NTG
         I=-K
      IF ((ZIERG(13:13) .EQ. 'y') .OR. (ZIERG(13:13) .EQ. 'Y'))
     * WRITE (MDMON,182) K,NUGEB,PNKTG(K)/R,PAKTG(K)/R,WSATG(K)/R,
     *         EPTG(K)/R,ERTG(K)/R,EITG(K)/R,EBTG(K)/R,R0TG(K)/R,
     *         R1TG(K)/R,R2TG(K)/R,RGETG(K)/R,
     *         SSOTG(K),SITG(K),SSMTG(K),SUZTG(K),SLZTG(K)

      IF ((ZIERG(7:7) .EQ. 'y') .OR. (ZIERG(7:7) .EQ. 'Y'))
     * WRITE (MDR,181) NRGEB,K,I,HOEHTG(K),AETG(K),
     *         PAKTG(K)/R,WSATG(K)/R,EPTG(K)/R,ERTG(K)/R,EITG(K)/R,
     *         EBTG(K)/R,R0TG(K)/R,R1TG(K)/R,R2TG(K)/R,RGETG(K)/R,
     *         SSOTG(K),SITG(K),SSMTG(K),SUZTG(K),SLZTG(K)

186    CONTINUE

       CALL BILANZ (GEBIL,PAKSM,ERSM,RGESSM,SSOB,SSOM,SSOD,SIB,SIM,SID,
     *              SSMB,SSMM,SSMD,SUZB,SUZM,SUZD,SLZB,SLZM,SLZD )

152    FORMAT (  /,  'WB-BALANCE: TF NRTFL    P  -   E  -   R  -',
     *            '(SSOE-SSOA)-( SIE- SIA)-(SSME-SSMA)-(SUZE-SUZA)',
     *            '-(SLZE-SLZA)=BILANZ' )
154    FORMAT (  9X,I4,I6,3F7.1,11F6.1,' mm')

! ------------------------------------------------------------------------------
!    Closing outpout files and files from shadowing
      IF (SHADST .GT. 0) THEN
         CLOSE (MSHDH)
      ENDIF
      IF (MON .NE. 1) THEN
         CLOSE (MDATN(1))
         CLOSE (MDATN(2))
         CLOSE (MDATN(3))
         CLOSE (MDATN(4))
         CLOSE (MDATN(5))
         IF (IRGL .LT. 5) CLOSE (MDATN(6))
      ENDIF
      IF ((IERG.EQ.2) .OR. (IERG.EQ.4) .OR. (IERG.EQ.5) .OR.
     * (IERG.EQ.6))  CLOSE (MDTAG)
      IF ((IERG.EQ.3) .OR. (IERG.EQ.5) .OR. (IERG.EQ.6))
     * CLOSE (MDMON)
	return

999   continue

      call messagerun (1, 'Error while writing outputs')
	stop

	end
