!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

! ------------------------------------------------------------------------------
! Reads meteorological forecast file - April 2004
! ------------------------------------------------------------------------------

      MODUL(1)='[Scaling Parameters]'
      MODUL(2)='[Meteorological forecast]'

! ------------------------------------------------------------------------------
c     Eingabe der Name der Inputdatei
! ------------------------------------------------------------------------------

      call posnam (NAMEIN,2,pos)
	  call messagerun (1,NAMEIN(1:pos)//'.fcast')
      OPEN (351,FILE=NAMEIN(1:pos)//'.fcast',STATUS='OLD',ERR=298)

! ------------------------------------------------------------------------------
c    Einlesen der Inputdatei
! ------------------------------------------------------------------------------

233    CONTINUE

      LN=-1

      READ (351,'(A78)',END=299,err=299) kopf

      DO I=1,2
         IF (kopf(1:12) .EQ. MODUL(I)(1:12)) THEN
            LN=I
            call messagerun (1,MODUL(I)//' OK')
         ENDIF
      END DO

! ------------------------------------------------------------------------------
!     '[Scaling Parameters]'
! ------------------------------------------------------------------------------

      IF (LN .EQ. 1) THEN
          READ (351,*,err=299) rqtime
		  qtime=int(rqtime)
          READ (351,*,err=299) lastrunoff
      ENDIF


! ------------------------------------------------------------------------------
!     '[Meteorological forecast]'
! ------------------------------------------------------------------------------

      IF (LN .EQ. 2) THEN
          READ (351,*,err=299) fortype
          READ (351,*,err=299) fordays
		  fnext=0
		  forensemble=0
234    continue
      READ (351,'(A78)',END=299) kopf
      call messagerun (2,kopf(1:28))

      IF (kopf(1:15) .eq. '[Precipitation]') THEN
	  fordt(1)=1440
          do I=1,fordays
		  do Y=1,int(1440/fordt(1))
          READ (351,*,END=299,err=299) fordummy,
     *    forrain(I,1,Y),forrain(I,2,Y),forrain(I,3,Y),
     *    rainshape(I,1,Y),rainshape(I,2,Y),rainshape(I,3,Y),
     *    rainshape(I,4,Y)
	      END DO
          END DO
      GOTO 234
      END IF

      IF (kopf(1:13) .eq. '[Temperature]') THEN
	  fordt(2)=1440
          do I=1,fordays
		  do Y=1,int(1440/fordt(2))
          READ (351,*,END=299,err=299) fordummy,
     *    fortemp(I,1,Y),fortemp(I,2,Y),fortemp(I,3,Y),
     *    tampli(I,Y),tshape(I,Y)
	      END DO
          END DO
      GOTO 234
      END IF

      IF (kopf(1:18) .eq. '[Global Radiation]') THEN
	  fordt(3)=1440
          do I=1,fordays
		  do Y=1,int(1440/fordt(3))
          READ (351,*,END=299,err=299) fordummy,forrad(I,Y)
          END DO
          END DO
      GOTO 234
      END IF

      IF (kopf(1:19) .eq. '[Relative Humidity]') THEN
	  fordt(4)=1440
          do I=1,fordays
		  do Y=1,int(1440/fordt(4))
          READ (351,*,END=299,err=299) fordummy,forrelh(I,Y)
          END DO
		  END DO
      GOTO 234
      END IF

      IF (kopf(1:12) .eq. '[Wind speed]') THEN
	  fordt(5)=1440
          do I=1,fordays
		  do Y=1,int(1440/fordt(5))
          READ (351,*,END=299,err=299) fordummy,forwind(I,Y)
          END DO
		  END DO
      GOTO 234
      END IF

      IF (kopf(1:28) .eq. '[Relative sunshine duration]') THEN
	  fordt(6)=1440
          do I=1,fordays
		  do Y=1,int(1440/fordt(6))
          READ (351,*,END=299,err=299) fordummy,forsuns(I,Y)
          END DO
          END DO
      GOTO 234
      END IF

      END IF

      goto 233

298   CONTINUE


      IF (LN .GT. 0) THEN
         call messagerun (2,'Fehler in Modul '//MODUL(LN))
      ENDIF
      call messagerun (2,' ')
      call messagerun (2,'Fehler in der Inputdatei:')
      call messagerun (2,'- REAL statt INTEGER ')
      call messagerun (2,'- ZAHL statt BUCHSTAB, oder umgekehrt ')
      call messagerun (2,'- Dateiname laenger als 12 Buchstaben ')
299   CONTINUE

      CLOSE(351)
