!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------


      SUBROUTINE SHADMOIH (TAG,MON,JAHR,DAT,IPRI,MDR,NTFL,HYDTNR,
     *                     SHADTFL,SHADETFL,SHADTI,TSA,TSU)

!     This subroutine interpolates hourly values of shadowing for each hydrotope
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      INTEGER TAG,MON,JAHR,DAT(12),IPRI,MDR,NTFL,HYDTNR
      REAL SHADTFL(NTFL,24),SHADETFL(NTFL,24),SHADTI(24)
      INTEGER TSA,TSU

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------
      INTEGER I
      REAL RHG,RSHAD,RSHADE,RTAG

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

2     FORMAT ( 'Datum:',I3,'.',I3,'. ',I5,12F5.2,/,20X,12F5.2 )
      DO I=1,24
         SHADTI(I)=SHADTFL(HYDTNR,I)
         IF ((I .LE. TSA) .and. (SHADTI(I) .EQ. 0.0)) SHADTI(I)=1.0
         IF ((I .GE. TSU) .and. (SHADTI(I) .EQ. 0.0)) SHADTI(I)=1.0
      ENDDO
      IF ((MON.EQ.12).and.(TAG.EQ.31)) THEN
      DO I=1,24
         SHADTI(I)=SHADETFL(HYDTNR,I)
         IF ((I .LE. TSA) .and. (SHADTI(I) .EQ. 0.0)) SHADTI(I)=1.0
         IF ((I .GE. TSU) .and. (SHADTI(I) .EQ. 0.0)) SHADTI(I)=1.0
      ENDDO
      GOTO 10
      ENDIF

      IF((TAG.EQ.1).or.(TAG.EQ.16))THEN
         GOTO 10
      ELSE
         DO I=1,24
            RSHAD=SHADTFL(HYDTNR,I)
            RSHADE=SHADETFL(HYDTNR,I)
            IF (RSHAD .EQ. RSHADE) CYCLE
            IF (RSHADE .GT. RSHAD) THEN
               RHG=RSHADE-RSHAD
               IF (TAG .LT. 16) THEN
                  RHG=RHG/15.0
                  RTAG=(Tag-1)*1.0
                  SHADTI(I)=RSHAD+(RHG*RTAG)
               ENDIF
               IF ((TAG .GT. 16).and.(TAG .LE. 31)) THEN
                  RTAG=(DAT(MON)-16)*1.0
                  IF (MON .EQ. 12) RTAG=15.0
                  RHG=RHG/RTAG
                  RTAG=(TAG-16)*1.0
                  SHADTI(I)=RSHAD+(RHG*RTAG)
               ENDIF
            ENDIF
            IF (RSHAD .GT. RSHADE) THEN
               RHG=RSHAD-RSHADE
               IF (TAG .LT. 16) THEN
                  RHG=RHG/15.0
                  RTAG=(TAG-1)*1.0
                  SHADTI(I)=RSHAD-(RHG*RTAG)
               ENDIF
               IF ((TAG .GT. 16).and.(TAG .LE. 31)) THEN
                  RTAG=(DAT(MON)-15)*1.0
                  IF (MON .EQ. 12) RTAG=15.0
                  RHG=RHG/RTAG
                  RTAG=(TAG-16)*1.0
                  SHADTI(I)=RSHAD-(RHG*RTAG)
               ENDIF
            ENDIF
         ENDDO
      ENDIF
10    CONTINUE
      IF (IPRI .GT. 0) THEN
          WRITE (MDR,2) TAG,MON,JAHR,(SHADTI(I),I=1,24)
      ENDIF

! ---------------------------------------------------------------------
      RETURN
      END
