!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE SHADMORH(DS,TAG,MON,MSD,NTFL,SHADTFL,SHADETFL)

!     This subroutine reads hourly values of shadowing for each hydrotope
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      INTEGER DS,TAG,MON,MSD,NTFL
      REAL SHADTFL(NTFL,24),SHADETFL(NTFL,24)

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------
      INTEGER DSTAG
      INTEGER J,K,TAGI,MONI,STDI,NKZ,TAGB,MONB
      REAL, ALLOCATABLE:: SHADHF(:)
      CHARACTER*72 ZEIKE

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------


2     FORMAT ( A72 )
4     FORMAT (  ' Today it is the:',I3,'.',I3,'.',I5,
     *          ' Input shadowing dates:',I3,'.',I3,'. DS=',I5,
     *          ' STD=',I3 )



      ALLOCATE (SHADHF(NTFL))
      NKZ=1

      IF  (DS .EQ. 1) THEN
           DSTAG=TAG
           TAG=1
           IF (DSTAG .GE. 16) TAG=16
      ENDIF
      IF ((MON .EQ. 12) .and. (TAG .EQ. 31)) THEN
           REWIND(MSD)
           DS=0
           GOTO 10
      ENDIF

      IF ((TAG.NE.1) .and. (TAG.NE.16)) GOTO 10

      DO J=1,NKZ
         IF  (DS .EQ. 1) READ (MSD,2) ZEIKE
      ENDDO
      MONB=MON
      TAGB=1
      IF ((MON .EQ. 1) .and. (TAG .EQ. 1)) GOTO 6
      IF (TAG .EQ. 16) TAGB=1
      IF (MON .EQ. 12) TAGB=31
      IF (TAG .EQ. 1) TAGB=16
6     CONTINUE
      DO  K=1,24
          READ (MSD,*) MONI,TAGI,STDI, (SHADHF(J), J=1,NTFL)
          DO J=1,NTFL
             SHADTFL(J,K)=SHADHF(J)
          ENDDO
      ENDDO
      IF ((MON .EQ. 1) .and. (TAG .EQ. 1)) GOTO 16
      IF  (DS .EQ. 1) THEN
      IF (MONI .LT. MONB) GOTO 6
      IF ((MONI .EQ. MONB) .and. (TAGI .EQ. TAGB)) THEN
          DO  K=1,48
          IF (DSTAG .GE. 16) EXIT
          BACKSPACE(MSD)
          ENDDO
          IF (DSTAG .LT. 16) GOTO 6
      ENDIF
      IF (TAGI .LT. 16) THEN
          IF (DSTAG .GE. 16) THEN
          DO  K=1,24
          READ (MSD,*) MONI,TAGI,STDI, (SHADHF(J), J=1,NTFL)
          DO J=1,NTFL
             SHADTFL(J,K)=SHADHF(J)
          ENDDO
          ENDDO
          ENDIF
      ENDIF
      ENDIF
16    CONTINUE
      DO  K=1,24
          READ (MSD,*) MONI,TAGI,STDI, (SHADHF(J), J=1,NTFL)
          DO J=1,NTFL
             SHADETFL(J,K)=SHADHF(J)
          ENDDO
      ENDDO
      DO  K=1,24
          BACKSPACE(MSD)
      ENDDO

10    CONTINUE
      DEALLOCATE (SHADHF)
      IF  (DS .EQ. 1) TAG=DSTAG

! ---------------------------------------------------------------------
      RETURN
      END
