!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE TAGZAHL (TAG,MONATNR,TAGNR,SJAHR)

!     This subroutine computes on the basis of the actual day TAG,
!     and month MONATNR the number of the day TAGNR. Leap years are accounted
!     throug the variable SJAHR
!     Version 1.0	11. September 1997	F. Koch / P. Koenig / M. Zappa
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables

      INTEGER TAG,TAGNR,MONATNR,MBI
      CHARACTER*1       SJAHR

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------

      INTEGER     I,MONATZAHL(12)

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

2     MONATZAHL(1)=31
      MONATZAHL(2)=59
      MONATZAHL(3)=90
      MONATZAHL(4)=120
      MONATZAHL(5)=151
      MONATZAHL(6)=181
      MONATZAHL(7)=212
      MONATZAHL(8)=243
      MONATZAHL(9)=273
      MONATZAHL(10)=304
      MONATZAHL(11)=334
      MONATZAHL(12)=365

      MBI=6

      IF ((SJAHR .EQ. 'Y') .OR. (SJAHR .EQ. 'y')) THEN
        DO I=2,12
        MONATZAHL(I)=MONATZAHL(I)+1
        ENDDO
      ENDIF

      IF ( MONATNR .EQ. 1 ) TAGNR=TAG

      IF ( MONATNR .GT. 1 ) TAGNR=MONATZAHL(MONATNR-1)+TAG

      IF (TAGNR .LT. 1) THEN
        WRITE (MBI,17) TAGNR
        STOP ' Error in DATU'
      END IF
      IF (TAGNR .GT. 366) THEN
        WRITE (MBI,16) TAGNR
        STOP ' Error in DATU'
      END IF

17	FORMAT (' DATU-E-END	Day number below 0 ',I4)
16	FORMAT (' DATU-E-END	Day number above 366 ',I4)
      RETURN
      END
