!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE TOPTRHOPT (topt,rhopt,RHHVAL,rhdval,tairh,taird,
     *                       lcol,lrow,hharr,rnodat)

	use realtime

!     This subroutine reads the incoming meteorological information
!     from grids
!--------------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

	INCLUDE 'wasim.h'
! Hourly values
	INTEGER hh1,fcbsp,lcol,lrow,pos,posi1,hharr,topt,rhopt
      REAL RHHVAL(hharr,lcol,lrow)	! Hourly values
      REAL TAIRH(hharr,lcol,lrow)		! Hourly values air temperature
! Daily sums and averages
      REAL RHDVAL(lcol,lrow),TAIRD(lcol,lrow)

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------

      INTEGER TAGI,LTAGI,		! begin day
     *        MONI,LMONI,			! begin month
     *        JAHRI,DTMIN,STP,			! begin year
     *        p,loi  ! parameters for loops
      REAL TAIR,RHUMIT,DAD,ldadm,LRL 	! Variables for the conversion of water vapour into relative humidity
      REAL dummy			! if data not available
	character*100 rdir,rnam
	character*256 rfile,dirmeteo,filenr
	character*2 sa

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

!      print*, topt,rhopt

      do ycoor=lrow,1,-1
	do xcoor=1,lcol
      if (int(taird(xcoor,ycoor)) .eq. int(rnodat)) then
	cycle
	else


 	do loi=1,24
      if (topt .eq. 2) then
      if (loi .eq. 1) TAIRD(xcoor,ycoor)=TAIRD(xcoor,ycoor)-273.15
      TAIRh(loi,xcoor,ycoor)=TAIRh(loi,xcoor,ycoor)-273.15
	end if
      if (topt .eq. 3) then
      if (loi .eq. 1) TAIRD(xcoor,ycoor)=(TAIRD(xcoor,ycoor)-32.)*5./9.
      TAIRh(loi,xcoor,ycoor)=(TAIRh(loi,xcoor,ycoor)-32.)*5./9.
	end if

	IF (RHOPT .EQ. 2) CYCLE			! Already relative humidity 0..1

      IF (RHOPT .EQ. 1) THEN				! Water vapour in hPa
	    if (loi .eq. 1) RHDVAL(xcoor,ycoor)=0
          TAIR=TAIRH(loi,xcoor,ycoor)
          RHUMIT=100.0
          CALL VAP2 (TAIR,RHUMIT,ldadm)
          DAD=RHHVAL(loi,xcoor,ycoor)
	    DAD=MAX(0.1,DAD)
          LRL=DAD/ldadm
          IF (LRL .GT. 1.0) LRL=1.0
          IF (LRL .LE. 0.0) LRL=0.01
          RHHVAL(loi,xcoor,ycoor)=LRL
          RHDVAL(xcoor,ycoor)=RHDVAL(xcoor,ycoor)+
     *                        RHHVAL(loi,xcoor,ycoor)/24.
	end if

 	end do
	end if

	END DO
	END DO


112   CONTINUE

      RETURN

      END


!--------------------------------------------------------------------------
      SUBROUTINE SSDTOPHH (PHHVAL,Pdval,ssdd,lcol,lrow,hharr,rnodat)

	use realtime

!     This subroutine reads the incoming meteorological information
!     from grids
!--------------------------------------------------------------------------

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------

	INCLUDE 'wasim.h'
! Hourly values
	INTEGER hh1,fcbsp,lcol,lrow,pos,posi1,hharr,topt,rhopt
	integer nhh,loi,lbe,le
      REAL PHHVAL(hharr,lcol,lrow)	! Hourly values
! Daily sums and averages
      REAL PDVAL(lcol,lrow),SSDD(lcol,lrow)

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

!      print*, topt,rhopt

      do ycoor=lrow,1,-1
	do xcoor=1,lcol
      if (int(ssdd(xcoor,ycoor)) .eq. int(rnodat)) then
	cycle
	else
	nhh=int(0.5+24./(max(1.,SSDD(xcoor,ycoor)*1.66)))
	lb=1
	le=24
	lb=max(1,12-nhh/2)
	le=min(24,(lb+nhh-1))

!	print*,nhh,lb,le

 	do loi=1,24
	if (loi .lt. lb) then
      PHHVAL(loi,xcoor,ycoor)=0.
	else if (loi .gt. le) then
      PHHVAL(loi,xcoor,ycoor)=0.
	else
      PHHVAL(loi,xcoor,ycoor)=PDVAL(xcoor,ycoor)/float(nhh)
	end if
	end do
	end if

	END DO
	END DO


112   CONTINUE

      RETURN

      END
