!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

! ------------------------------------------------------------------------------
! Dr. Thomas "Eddy" W�hling - Updating procedure
! September-October 2005
! Adapted by M.Zappa for use in every basin
! ------------------------------------------------------------------------------
	if ((jnUp.eq.'y').and.(updatejn.eq.'y')) then

	IF (upiter.	gt.12) then
		if (ausgabejn.eq.'y')
     *		   call messagerun (1,'max. number of updating iterations = 12')
		if (ausgabejn.eq.'y') print *, uphourold, uphour
		!if (uphourold.eq.1) uphourold=uphourold-1
		jnmeas(uphourold+1)=0
		uphour=uphourold+2
		upiter=0
		okidoki='y'
	end if


6605	if (((RGEHM(uphour).GT.(1+uptol)*QmesDat(uphour)).or.(RGEHM(uphour)
     *		.LT.(1-uptol)*QmesDat(uphour))).and.(jnmeas(uphour).gt.0))
     *	        Then
			rest=RGEHM(uphour)*100/QmesDat(uphour)-100
			if (ausgabejn.eq.'y')
     *	     write (9447,*) DATUMCHAR, uphour, upiter, upfac(uphour),
     *			   rest,'%  updating'
			WRITE (6545,'(5I4,2F8.2)') JAHR,MON,TAG,uphour,
     *     			upiter,upfac(uphour),rest
     			okidoki='n'
	else
			okidoki='y'
			if (uphour.gt.uphourold) then
				upiter=0
				uphourold=uphour
	        end if
			if (uphour.eq.iee) then
				uphourold=1
				DO 6695 myi=ibb,iee
				WRITE (6546,'(4I4,1F8.2)') JAHR,MON,TAG,myi-1,
     *     				RGEHM(myi)*AELHG/3.6
6695				continue
!				print *, 'End of day'
			end if
			rest=RGEHM(uphour)*100/QmesDat(uphour)-100
			if (ausgabejn.eq.'y')
     *			write (9447,*) DATUMCHAR, uphour, upiter, upfac(uphour),
     *			   rest,'%',okidoki
			WRITE (6545,'(5I4,2F8.2)') JAHR,MON,TAG,uphour,
     *     			upiter,upfac(uphour),rest
			if (upacthour.eq.uphour) then
				upfacold=1
				restold=0
				upacthour=0
			end if
			uphour=uphour+1
			if (uphour.gt.iee) GOTO 6606
			GOTO 6605
	end if

	if (okidoki.eq.'n') then
	if (ausgabejn.eq.'y')
     *	print *, upfac(uphour), upfacold, rest, restold
! Berechnung des 2. Punktes der Sekante beim ersten Mal:
	if (upfac(uphour).eq.1) then
		if (rest.lt.0) upfacnew=upfac(uphour)*1.3
		if (rest.gt.0) upfacnew=upfac(uphour)*0.7
	else
! Berechnung des 2. Punktes der Sekante bei allen folgenden Iterationen:
		upfacnew=upfac(uphour)-rest*((upfac(uphour)-upfacold)
     *       		/(rest-restold))
          if (upfacnew.lt.0.001) upfacnew=0.001
		if (upfacnew.gt.10000) upfacnew=10000
	end if
	upacthour=uphour
	upfacold=upfac(uphour)
	upfac(uphour)=upfacnew
	restold=rest
	if (upfacnew.eq.upfacold) then
		if (ausgabejn.eq.'y') print *,'Faktor gleich!!!'
		jnmeas(uphourold+1)=0
		uphour=uphourold+2
		if (uphour.gt.iee) uphour=iee !#########
		upiter=0
		okidoki='y'
		GOTO 6605
	end if

	if (ausgabejn.eq.'y')
     *	print *, upfac(uphour), upfacold, rest, restold

!	print *,'reading state'
      call posnam(dirstate,1,NN)
	loadnam=dirstate(1:NN)//'updatestate.sav'
	INQUIRE (file=loadnam,EXIST=jnDatei)
	IF (.NOT.jnDatei) print *,'*** update state does not exist!!! ***'
      include 'readstateup.inc'
	write (kopf,'(I2.2,A,I2.2)') (upiter+1),
     * trim(' Iteration '//datumchar//'-'),uphour
	if (uphour .eq. 1) then
	call messagerun (2,trim(kopf))
	else
	call messagerun (0,trim(kopf))
	end if



	upiter=upiter+1
	uphour=1
!     Setting hourly fields to 0
      do i=ibb,iee
	    PNKHM(i)=0.0
          PAKHM(i)=0.0
          WSAHM(i)=0.0
          EPHM(i)=0.0
          ERHM(i)=0.0
          EIHM(i)=0.0
          EBHM(i)=0.0
          R0HM(i)=0.0
          R1HM(i)=0.0
          R2HM(i)=0.0
          RGB1HM(i)=0.0
	    RGB2HM(i)=0.0
	    RGB3HM(i)=0.0
          RGEHM(i)=0.0
          SSMHM(i)=0.0
          SSOHM(i)=0.0
          SIHM(i)=0.0
          SUZHM(i)=0.0
          SLZHM(i)=0.0
	    RICEHM(I)=0.0
	    WICEHM(I)=0.0
	    RICSHM(I)=0.0
	    RICFHM(I)=0.0
	end do
	      rices=0
      DS=DS+1
      NDTD=24
      SSOM=0.0
      SIM=0.0
      SSMM=0.0
      SUZM=0.0
      SLZM=0.0
      GEBIL=0.0
      GLACSS=0.0
       PNKSM=0.0
       PAKSM=0.0
       WSASM=0.0
       EPSM=0.0
       ERSM=0.0
       EISM=0.0
       EBSM=0.0
       R0SM=0.0
       R1SM=0.0
       R2SM=0.0
       RGESSM=0.0
	GOTO 6697
	end if
	end if
! ------------------------------------------------------------------------------

6606  continue

! ------------------------------------------------------------------------------
