!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE VAP2 (TAIR,RHUMIT,VAP)

!     This subroutine computes the water vapour pressure  (hPa) at given
!     air temperature TAIR (�C) and the relative humidity RHUMIT (%)
!     after GOFF-GRATCH,JG 1997
! ---------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables

      REAL VAP,RHUMIT,TAIR

! ---------------------------------------------------------------------
!     Internal Variables
! ---------------------------------------------------------------------
      REAL A,B,LOGVAP

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

	A= 273.16/(TAIR +273.15)
      B= 1 -A
      LOGVAP= 10.79574*B +5.028*LOG10(A)
     *        +1.50475E-4*(1 -10**(-8.2969*(1/A -1)))
     *        +0.42873E-3*(10**(4.76955*B) -1) +0.78614

      VAP=RHUMIT*0.01*10**LOGVAP

      RETURN

      END
