!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE WDATHD1 ( IERG,NUGEB,AE,AELHG,IART,DT,NTFL,
     *           NTG,NTGFL,AETG,ATG,LANGWSF,KURZWSF,VFEUCHTF,
     *           TAGA,MONA,JAHRA,TAGE,MONE,JAHRE,GEOBREITE,
     *           ZG,ZN,CLANG,CKURZ,CVENT,ZEIKE,ZEIPM,
     *           MDR,MDMIT,MDSTD,MDTAG,MDMON,MDLOG )

!     This subroutine writes the headers for the different output files
! ---------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      INTEGER IERG,NUGEB,IART,NTFL,NTG,NTGFL(999)
      INTEGER MDR,MDMIT,MDSTD,MDTAG,MDMON,MDLOG
      INTEGER TAGA,MONA,JAHRA,TAGE,MONE,JAHRE
      INTEGER LANGWSF,KURZWSF,VFEUCHTF
      REAL DT,AE,AELHG,GEOBREITE,AETG(999),ATG(999)
      CHARACTER*56 ZEIKE,ZEIPM(6)
      CHARACTER*31 CKURZ(17),CLANG(10),CVENT(3)
      CHARACTER*32 ZG,ZN

! ---------------------------------------------------------------------
!     Local Variables
! ---------------------------------------------------------------------
      INTEGER MDRU,NRAR,I,K,L,M,IFE(999)
      INTEGER IYR,IMONT,IDAY,IHR,IMIN

      NRAR=1
      MDRU=MDR

! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------
1     CONTINUE
129   FORMAT ( '  ' )
130   FORMAT (/,'  Programm PREVAH  ETHZ-Version 2.0  -  June/2003',
     *        /,'  ==================================================',
     *        /)
131   FORMAT (  '                     LOG-FILE                 '  )
132   FORMAT ( / )
133   FORMAT (  '            File including daily values       '  )
159   FORMAT (  '            File including hourly values      '  )
135   FORMAT (  '            File including monthly values     '  )

      WRITE (MDLOG,130)
      IF (MDRU .EQ. 42) WRITE (MDLOG,131)
      IF (MDRU .EQ. 8 ) WRITE (MDRU,133)
      IF (MDRU .EQ. 9 ) WRITE (MDRU,135)
      IF (MDRU .EQ. 11) WRITE (MDRU,159)

134   FORMAT ('    PREVAH was run on ',i2,'.',i2,'.',i4,
     *        ' at  ',i2,':',i2)
c      CALL GETDAT (IYR,IMONT,IDAY)
c      CALL GETTIM (IHR,IMIN,ISEC,I100TH)
      iday=8
      imont=8
      iyr=2003
      ihr=8
      imin=30
      WRITE (MDLOG,134) iday,imont,iyr,ihr,imin
      write (MDLOG,'('' '')')

136   FORMAT ( 1X,A56)
138   FORMAT (  ' Catchment designation      : ',A32,
     *        /,' Gauge name                 : ',A32,
     *        /,' Catchment identifier       : ',I7   )
140   FORMAT (  ' Total catchment area       : ',F7.2,' km**2 (=AE) ',
     *        /,' Mapper area                : ',F7.2,' km**2 (=AELHG)'
     *          )
142   FORMAT (  ' Sub-catchments         TG  : ',I5,
     *        /,' Number of HRUs         TFL : ',I5   )
143   FORMAT (  ' TG-Nr.                     : ',10I5 )
144   FORMAT (  ' Number of HRUs             : ',10I5 )
156   FORMAT (  ' Partial areas      .(km**2): ',10F5.1 )
158   FORMAT (  ' Portion of area      TG (%): ',10F5.1 )
146   FORMAT (  ' Latitude (deg)             : ',F7.2,' deg ' )
148   FORMAT (  ' Time step-DT               : ',F7.1,' Hour(s)' )
      DO 150 I=1,NTG
         IFE(I)=I
150   CONTINUE

      WRITE (MDLOG,138) ZG,ZN,NUGEB
      WRITE (MDLOG,140) AE,AELHG
      WRITE (MDLOG,142) NTG,NTFL
      DO M=1,NTG,10
      L=M
      K=L+9
	K=MIN(k,NTG)
      WRITE (MDLOG,143) (IFE(I),I=L,K)
      WRITE (MDLOG,144) (NTGFL(I),I=L,K)
      WRITE (MDLOG,156) (AETG(I),I=L,K)
      WRITE (MDLOG,158) (ATG(I),I=L,K)
	END DO

      WRITE (MDLOG,146) GEOBREITE
      WRITE (MDLOG,148) (DT/60.0)
      WRITE (MDLOG,129)
      WRITE (MDLOG,136) ZEIKE
      L=IART+1
      WRITE (MDLOG,136) ZEIPM(L)
      write (MDLOG,'('' Estimation of LW-Rad   '',a)') clang(langwsf+1)
      write (MDLOG,'('' Estiamtion of SW-Rad   '',a)') ckurz(kurzwsf+1)
      write (MDLOG,'('' Aereodynamic-term      '',a)')cvent(vfeuchtf+1)

154   FORMAT (  ' Investigated time range    : ',i2,'.',i2,'.',i4,' - ',
     *          i2,'.',i2,'.', i4 )
      WRITE (MDLOG,154) TAGA,MONA,JAHRA,TAGE,MONE,JAHRE

      IF (NRAR .EQ. 1) THEN
         NRAR=2
         MDRU=MDMIT
         GOTO 1
      ENDIF
      IF (NRAR .EQ. 2) THEN
         NRAR=3
         MDRU=MDSTD
         IF ((IERG.EQ.1) .OR. (IERG.EQ.4) .OR. (IERG.EQ.6)) THEN
            GOTO 1
         ENDIF
      ENDIF
      IF (NRAR .EQ. 3) THEN
         NRAR=4
         MDRU=MDTAG
         IF ((IERG.EQ.2) .OR. (IERG.EQ.4) .OR. (IERG.EQ.5) .OR.
     *      (IERG.EQ.6))  THEN
            GOTO 1
         ENDIF
      ENDIF
      IF (NRAR .EQ. 4) THEN
         NRAR=5
         MDRU=MDMON
         IF ((IERG.EQ.3) .OR. (IERG.EQ.5) .OR. (IERG.EQ.6)) THEN
            GOTO 1
         ENDIF
      ENDIF

! ---------------------------------------------------------------------

      RETURN
      END
