!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

      SUBROUTINE WDATHD2 (IERG,MDMIT,MDSTD,MDTAG,MDMON,AELHG, EGNAM)

!     This subroutine writes the headers for the different output files
! ---------------------------------------------------------------------

      implicit none

! ---------------------------------------------------------------------
!     Common Variables
! ---------------------------------------------------------------------
      INTEGER IERG,MDMIT,MDSTD,MDTAG,MDMON
	REAL AELHG
	CHARACTER*32 EGNAM


! ---------------------------------------------------------------------
!     Begin
! ---------------------------------------------------------------------

32    FORMAT (  ' 1  2  3  4  5    6  ',2X,'  7  ',2X,'  8  ',2X,
     *         '  9  ',2X,' 10  ',2X,'  11 ',2X,'   12',2X,'   13',2X,
     *          '   14',2X,'   15',2X,'   16',2X,'  17 ',2X,'  18 ',
     *          2X,'   19',2X,'  20 ',2X,'  21 ',2X,'  22 ' )
33    FORMAT (  '   1     2    3  ',2X,'  4  ',2X,'  5  ',2X,'  6',
     *          4X,'   7  ',2X,'  8 ',2X,'    9',2X,'   10',2X,
     *          '   11',2X,'  12',2X,'   13',2X,'   14 ',2X,'  15 ',
     *          2X,'   16',2X,'  17 ',2X,'  18 ',2X,'  19 ,',2X,
     *          '  19' )
34    FORMAT (  'JJ MM DD TI FN NRTFL',2X,' P-uk',2X,'P-kor',2X,
     *          'P-SME',2X,' EPOT',2X,' EREA',2X,'   EI',2X,'   EB',2X,
     *          '   RO',2X,'   R1',2X,'   R2',2X,' RGES',2X,'S-SNO',
     *          2X,'   SI',2X,'  SSM',2X,'  SUZ',2X,'  SLZ',
     *          2X,' RICE',2X,' RICS',2X,' RICF' )

36    FORMAT (  'JAHR MM  FN NRTFL ',2X,' P-uk',2X,'P-kor',2X,
     *          'P-SME',2X,' EPOT',2X,'EREA',2X,'   EI',2X,'   EB',2X,
     *          '   RO',2X,'  R1',2X,'   R2',2X,'  RGES',2X,'S-SNO',
     *          2X,'   SI',2X,'  SSM',2X,'  SUZ',2X,'  SLZ' )
37    FORMAT (  '  1   2   3   4   ',2X,'  5  ',2X,'  6  ',2X,'  7',
     *          4X,'   8 ',2X,'  9 ',2X,'   10',2X,'   11',2X,
     *          '   12',2X,'  13',2X,'   14',2X,'   15 ',2X,'  16 ',
     *          2X,'   17',2X,'  18 ',2X,'  19 ',2X,'  20 ' )

      WRITE (MDMIT,'(A30,1X,F12.3)') EGNAM(1:30),AELHG
      Write (MDMIT,'(A)') 'YYYY   MM   DD     P-uk    P-kor    P-SME'//
     * '     EPOT     EREA       EI       EB'//
     * '       RO       R1       R2     RGES'//
     * '    S-SNO       SI      SSM      SUZ      SLZ'//
     * '      BIL     GLAC      RG1      RG2      RG3    DIFGA'

      IF ((IERG.EQ.1) .OR. (IERG.EQ.4) .OR. (IERG.EQ.6)) THEN
        Write (MDSTD,34)
        WRITE (MDSTD,32)
      ENDIF

      IF ((IERG.EQ.2) .OR. (IERG.GT.3)) THEN
      Write (MDMIT,'(A)') 'YYYY   MM   DD    P-uk  P-kor  P-SME'//
     * '   EPOT   EREA     EI     EB'//
     * '     RO    R1     R2    RGES'//
     * '   S-SNO    SI    SSM    SUZ    SLZ'//
     * '    BIL   GLAC    RG1    RG2    RG3  DIFGA'
        WRITE (MDTAG,33)
      ENDIF
      IF ((IERG.EQ.3) .OR. (IERG.GT.4)) THEN
        Write (MDMON,36)
        WRITE (MDMON,37)
      ENDIF

! ---------------------------------------------------------------------

      RETURN
      END
