!-------------------------------------------------------------------------------
! FORHYCS: A spatially distributed model combining hydrology and forest dynamics
! Copyright (C) 1995-2004  J. Gurtz, M. Zappa et al.

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
c computes and writes wasim headers and writes grids
!-------------------------------------------------------------------------------

	if (.not. allocated(write2d)) ALLOCATE (write2D(ncol,nrow))

	do ycoor=1,nrow
	do xcoor=1,ncol
             write2D(xcoor,ycoor)=rnodat
             if (int(gezg(xcoor,ycoor)) .ne. int(rnodat)) then
             write2D(xcoor,ycoor)=WRGRD(xcoor,ycoor)
			 end if
	end do
	end do

	wstats(1)=0
	wstats(2)=1e8
	wstats(3)=-1e8
	wstats(4)=0
	wstats(5)=0
	wstats(6)=0

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(gezg(xcoor,ycoor)) .ne. int(rnodat)) then
		if (int(write2D(xcoor,ycoor)) .eq. int(rnodat)) cycle
		wstats(1)=wstats(1)+1
		wstats(2)=min(wstats(2),write2D(xcoor,ycoor))
		wstats(3)=max(wstats(3),write2D(xcoor,ycoor))
		wstats(4)=wstats(4)+write2D(xcoor,ycoor)
	  else
	    write2D(xcoor,ycoor)=nodat
	  endif
	end do
	end do

	wstats(5)=wstats(4)/wstats(1)

	do ycoor=nrow,1,-1
	do xcoor=1,ncol
        if (int(write2D(xcoor,ycoor)) .ne. int(nodat)) then
		wstats(6)=wstats(6)+(write2D(xcoor,ycoor)-wstats(5))**2
	  endif
	end do
	end do

	if (wstats(1) .gt. 1) then
		wstats(6)=(wstats(6)/(wstats(1)-1))**(0.5)
	else
		wstats(6)=0.0
	end if

	write (uwas) rcol
	write (uwas) rrow
	write (uwas) rxll
	write (uwas) ryll
	write (uwas) rgridsize
	write (uwas) rnodat

	do rloop=1,6
	    write (uwas) wstats(rloop)
	end do

	do ycoor=nrow,1,-1
         write (uwas) (write2D(xcoor,ycoor),xcoor=1,ncol)
	end do
	close (uwas)
      DEALLOCATE(write2d)
